=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@inin.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: ININ
http://www.inin.com

Terms of Service: https://developer.mypurecloud.com/tos

=end

require "uri"

module PureCloud
  class FaxApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # Delete a fax document.
    # 
    # @param document_id Document ID
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_documents_document_id(document_id, opts = {})
      delete_documents_document_id_with_http_info(document_id, opts)
      return nil
    end

    # Delete a fax document.
    # 
    # @param document_id Document ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_documents_document_id_with_http_info(document_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: FaxApi#delete_documents_document_id ..."
      end
      
      # verify the required parameter 'document_id' is set
      fail "Missing the required parameter 'document_id' when calling delete_documents_document_id" if document_id.nil?
      
      # resource path
      local_var_path = "/api/v2/fax/documents/{documentId}".sub('{format}','json').sub('{' + 'documentId' + '}', document_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FaxApi#delete_documents_document_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get a list of fax documents.
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size Page size (default to 25)
    # @option opts [Integer] :page_number Page number (default to 1)
    # @return [FaxDocumentEntityListing]
    def get_documents(opts = {})
      data, status_code, headers = get_documents_with_http_info(opts)
      return data
    end

    # Get a list of fax documents.
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size Page size
    # @option opts [Integer] :page_number Page number
    # @return [Array<(FaxDocumentEntityListing, Fixnum, Hash)>] FaxDocumentEntityListing data, response status code and response headers
    def get_documents_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: FaxApi#get_documents ..."
      end
      
      # resource path
      local_var_path = "/api/v2/fax/documents".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'pageSize'] = opts[:'page_size'] if opts[:'page_size']
      query_params[:'pageNumber'] = opts[:'page_number'] if opts[:'page_number']

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FaxDocumentEntityListing')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FaxApi#get_documents\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get a document.
    # 
    # @param document_id Document ID
    # @param [Hash] opts the optional parameters
    # @return [FaxDocument]
    def get_documents_document_id(document_id, opts = {})
      data, status_code, headers = get_documents_document_id_with_http_info(document_id, opts)
      return data
    end

    # Get a document.
    # 
    # @param document_id Document ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(FaxDocument, Fixnum, Hash)>] FaxDocument data, response status code and response headers
    def get_documents_document_id_with_http_info(document_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: FaxApi#get_documents_document_id ..."
      end
      
      # verify the required parameter 'document_id' is set
      fail "Missing the required parameter 'document_id' when calling get_documents_document_id" if document_id.nil?
      
      # resource path
      local_var_path = "/api/v2/fax/documents/{documentId}".sub('{format}','json').sub('{' + 'documentId' + '}', document_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FaxDocument')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FaxApi#get_documents_document_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Download a fax document.
    # 
    # @param document_id Document ID
    # @param [Hash] opts the optional parameters
    # @return [DownloadResponse]
    def get_documents_document_id_content(document_id, opts = {})
      data, status_code, headers = get_documents_document_id_content_with_http_info(document_id, opts)
      return data
    end

    # Download a fax document.
    # 
    # @param document_id Document ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(DownloadResponse, Fixnum, Hash)>] DownloadResponse data, response status code and response headers
    def get_documents_document_id_content_with_http_info(document_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: FaxApi#get_documents_document_id_content ..."
      end
      
      # verify the required parameter 'document_id' is set
      fail "Missing the required parameter 'document_id' when calling get_documents_document_id_content" if document_id.nil?
      
      # resource path
      local_var_path = "/api/v2/fax/documents/{documentId}/content".sub('{format}','json').sub('{' + 'documentId' + '}', document_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'DownloadResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FaxApi#get_documents_document_id_content\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get fax summary
    # 
    # @param [Hash] opts the optional parameters
    # @return [FaxSummary]
    def get_summary(opts = {})
      data, status_code, headers = get_summary_with_http_info(opts)
      return data
    end

    # Get fax summary
    # 
    # @param [Hash] opts the optional parameters
    # @return [Array<(FaxSummary, Fixnum, Hash)>] FaxSummary data, response status code and response headers
    def get_summary_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: FaxApi#get_summary ..."
      end
      
      # resource path
      local_var_path = "/api/v2/fax/summary".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FaxSummary')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FaxApi#get_summary\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a fax document.
    # 
    # @param document_id Document ID
    # @param body Document
    # @param [Hash] opts the optional parameters
    # @return [FaxDocument]
    def put_documents_document_id(document_id, body, opts = {})
      data, status_code, headers = put_documents_document_id_with_http_info(document_id, body, opts)
      return data
    end

    # Update a fax document.
    # 
    # @param document_id Document ID
    # @param body Document
    # @param [Hash] opts the optional parameters
    # @return [Array<(FaxDocument, Fixnum, Hash)>] FaxDocument data, response status code and response headers
    def put_documents_document_id_with_http_info(document_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: FaxApi#put_documents_document_id ..."
      end
      
      # verify the required parameter 'document_id' is set
      fail "Missing the required parameter 'document_id' when calling put_documents_document_id" if document_id.nil?
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling put_documents_document_id" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/fax/documents/{documentId}".sub('{format}','json').sub('{' + 'documentId' + '}', document_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FaxDocument')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FaxApi#put_documents_document_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
