=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@inin.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: ININ
http://www.inin.com

Terms of Service: https://developer.mypurecloud.com/tos

=end

require "uri"

module PureCloud
  class StationsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # Unassigns the user assigned to this station
    # 
    # @param station_id Station ID
    # @param [Hash] opts the optional parameters
    # @return [String]
    def delete_station_id_associateduser(station_id, opts = {})
      data, status_code, headers = delete_station_id_associateduser_with_http_info(station_id, opts)
      return data
    end

    # Unassigns the user assigned to this station
    # 
    # @param station_id Station ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def delete_station_id_associateduser_with_http_info(station_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: StationsApi#delete_station_id_associateduser ..."
      end
      
      # verify the required parameter 'station_id' is set
      fail "Missing the required parameter 'station_id' when calling delete_station_id_associateduser" if station_id.nil?
      
      # resource path
      local_var_path = "/api/v2/stations/{stationId}/associateduser".sub('{format}','json').sub('{' + 'stationId' + '}', station_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: StationsApi#delete_station_id_associateduser\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get station.
    # 
    # @param station_id Station ID
    # @param [Hash] opts the optional parameters
    # @return [Station]
    def get_station_id(station_id, opts = {})
      data, status_code, headers = get_station_id_with_http_info(station_id, opts)
      return data
    end

    # Get station.
    # 
    # @param station_id Station ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(Station, Fixnum, Hash)>] Station data, response status code and response headers
    def get_station_id_with_http_info(station_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: StationsApi#get_station_id ..."
      end
      
      # verify the required parameter 'station_id' is set
      fail "Missing the required parameter 'station_id' when calling get_station_id" if station_id.nil?
      
      # resource path
      local_var_path = "/api/v2/stations/{stationId}".sub('{format}','json').sub('{' + 'stationId' + '}', station_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Station')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: StationsApi#get_station_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get the list of available stations.
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size Page size (default to 25)
    # @option opts [Integer] :page_number Page number (default to 1)
    # @option opts [String] :sort_by Sort by (default to name)
    # @option opts [String] :name Name
    # @option opts [String] :id Comma separated list of stationIds
    # @option opts [String] :line_appearance_id lineAppearanceId
    # @return [StationEntityListing]
    def get_stations(opts = {})
      data, status_code, headers = get_stations_with_http_info(opts)
      return data
    end

    # Get the list of available stations.
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size Page size
    # @option opts [Integer] :page_number Page number
    # @option opts [String] :sort_by Sort by
    # @option opts [String] :name Name
    # @option opts [String] :id Comma separated list of stationIds
    # @option opts [String] :line_appearance_id lineAppearanceId
    # @return [Array<(StationEntityListing, Fixnum, Hash)>] StationEntityListing data, response status code and response headers
    def get_stations_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: StationsApi#get_stations ..."
      end
      
      # resource path
      local_var_path = "/api/v2/stations".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'pageSize'] = opts[:'page_size'] if opts[:'page_size']
      query_params[:'pageNumber'] = opts[:'page_number'] if opts[:'page_number']
      query_params[:'sortBy'] = opts[:'sort_by'] if opts[:'sort_by']
      query_params[:'name'] = opts[:'name'] if opts[:'name']
      query_params[:'id'] = opts[:'id'] if opts[:'id']
      query_params[:'lineAppearanceId'] = opts[:'line_appearance_id'] if opts[:'line_appearance_id']

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'StationEntityListing')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: StationsApi#get_stations\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
