=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@inin.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: ININ
http://www.inin.com

Terms of Service: https://developer.mypurecloud.com/tos

=end

require 'date'

module PureCloud
  class Annotation
    # The globally unique identifier for the object.
    attr_accessor :id

    attr_accessor :name

    attr_accessor :type

    # Offset of annotation in milliseconds.
    attr_accessor :location

    # Duration of annotation in milliseconds.
    attr_accessor :duration_ms

    # User that created this annotation (if any).
    attr_accessor :user

    # Text of annotation.
    attr_accessor :description

    # The word or phrase which is being looked for with speech recognition.
    attr_accessor :keyword_name

    # Actual confidence that this is an accurate match.
    attr_accessor :confidence

    # A unique identifier for the keyword set to which this spotted keyword belongs.
    attr_accessor :keyword_set_id

    # The keyword set to which this spotted keyword belongs.
    attr_accessor :keyword_set_name

    # The phonetic spellings for the phrase and alternate spellings.
    attr_accessor :utterance

    # Beginning time offset of the keyword spot match.
    attr_accessor :time_begin

    # Ending time offset of the keyword spot match.
    attr_accessor :time_end

    # Configured sensitivity threshold that can be increased to lower false positives or decreased to reduce false negatives.
    attr_accessor :keyword_confidence_threshold

    # A modifier to the evaluation score when the phrase is spotted in the agent channel.
    attr_accessor :agent_score_modifier

    # A modifier to the evaluation score when the phrase is spotted in the customer channel.
    attr_accessor :customer_score_modifier

    # The URI for this object
    attr_accessor :self_uri

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'id' => :'id',
        
        :'name' => :'name',
        
        :'type' => :'type',
        
        :'location' => :'location',
        
        :'duration_ms' => :'durationMs',
        
        :'user' => :'user',
        
        :'description' => :'description',
        
        :'keyword_name' => :'keywordName',
        
        :'confidence' => :'confidence',
        
        :'keyword_set_id' => :'keywordSetId',
        
        :'keyword_set_name' => :'keywordSetName',
        
        :'utterance' => :'utterance',
        
        :'time_begin' => :'timeBegin',
        
        :'time_end' => :'timeEnd',
        
        :'keyword_confidence_threshold' => :'keywordConfidenceThreshold',
        
        :'agent_score_modifier' => :'agentScoreModifier',
        
        :'customer_score_modifier' => :'customerScoreModifier',
        
        :'self_uri' => :'selfUri'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'id' => :'String',
        :'name' => :'String',
        :'type' => :'String',
        :'location' => :'Integer',
        :'duration_ms' => :'Integer',
        :'user' => :'User',
        :'description' => :'String',
        :'keyword_name' => :'String',
        :'confidence' => :'Float',
        :'keyword_set_id' => :'String',
        :'keyword_set_name' => :'String',
        :'utterance' => :'String',
        :'time_begin' => :'String',
        :'time_end' => :'String',
        :'keyword_confidence_threshold' => :'String',
        :'agent_score_modifier' => :'String',
        :'customer_score_modifier' => :'String',
        :'self_uri' => :'String'
        
      }
    end

    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'id']
        self.id = attributes[:'id']
      end
      
      if attributes[:'name']
        self.name = attributes[:'name']
      end
      
      if attributes[:'type']
        self.type = attributes[:'type']
      end
      
      if attributes[:'location']
        self.location = attributes[:'location']
      end
      
      if attributes[:'durationMs']
        self.duration_ms = attributes[:'durationMs']
      end
      
      if attributes[:'user']
        self.user = attributes[:'user']
      end
      
      if attributes[:'description']
        self.description = attributes[:'description']
      end
      
      if attributes[:'keywordName']
        self.keyword_name = attributes[:'keywordName']
      end
      
      if attributes[:'confidence']
        self.confidence = attributes[:'confidence']
      end
      
      if attributes[:'keywordSetId']
        self.keyword_set_id = attributes[:'keywordSetId']
      end
      
      if attributes[:'keywordSetName']
        self.keyword_set_name = attributes[:'keywordSetName']
      end
      
      if attributes[:'utterance']
        self.utterance = attributes[:'utterance']
      end
      
      if attributes[:'timeBegin']
        self.time_begin = attributes[:'timeBegin']
      end
      
      if attributes[:'timeEnd']
        self.time_end = attributes[:'timeEnd']
      end
      
      if attributes[:'keywordConfidenceThreshold']
        self.keyword_confidence_threshold = attributes[:'keywordConfidenceThreshold']
      end
      
      if attributes[:'agentScoreModifier']
        self.agent_score_modifier = attributes[:'agentScoreModifier']
      end
      
      if attributes[:'customerScoreModifier']
        self.customer_score_modifier = attributes[:'customerScoreModifier']
      end
      
      if attributes[:'selfUri']
        self.self_uri = attributes[:'selfUri']
      end
      
    end

    # Check equality by comparing each attribute.
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          name == o.name &&
          type == o.type &&
          location == o.location &&
          duration_ms == o.duration_ms &&
          user == o.user &&
          description == o.description &&
          keyword_name == o.keyword_name &&
          confidence == o.confidence &&
          keyword_set_id == o.keyword_set_id &&
          keyword_set_name == o.keyword_set_name &&
          utterance == o.utterance &&
          time_begin == o.time_begin &&
          time_end == o.time_end &&
          keyword_confidence_threshold == o.keyword_confidence_threshold &&
          agent_score_modifier == o.agent_score_modifier &&
          customer_score_modifier == o.customer_score_modifier &&
          self_uri == o.self_uri
    end

    # @see the `==` method
    def eql?(o)
      self == o
    end

    # Calculate hash code according to all attributes.
    def hash
      [id, name, type, location, duration_ms, user, description, keyword_name, confidence, keyword_set_id, keyword_set_name, utterance, time_begin, time_end, keyword_confidence_threshold, agent_score_modifier, customer_score_modifier, self_uri].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
