=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@inin.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: ININ
http://www.inin.com

Terms of Service: https://developer.mypurecloud.com/tos

=end

require 'date'

module PureCloud
  class CampaignNotification
    attr_accessor :id

    attr_accessor :name

    attr_accessor :date_created

    attr_accessor :date_modified

    attr_accessor :version

    attr_accessor :contact_list

    attr_accessor :queue

    attr_accessor :dialing_mode

    attr_accessor :script

    attr_accessor :edge_group

    attr_accessor :campaign_status

    attr_accessor :phone_columns

    attr_accessor :abandon_rate

    attr_accessor :dnc_lists

    attr_accessor :callable_time_set

    attr_accessor :call_analysis_response_set

    attr_accessor :caller_name

    attr_accessor :caller_address

    attr_accessor :outbound_line_count

    attr_accessor :errors

    attr_accessor :rule_sets

    attr_accessor :skip_preview_disabled

    attr_accessor :preview_time_out_seconds

    attr_accessor :single_number_preview

    attr_accessor :contact_sort

    attr_accessor :no_answer_timeout

    attr_accessor :call_analysis_language

    attr_accessor :priority

    attr_accessor :additional_properties

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'id' => :'id',
        
        :'name' => :'name',
        
        :'date_created' => :'dateCreated',
        
        :'date_modified' => :'dateModified',
        
        :'version' => :'version',
        
        :'contact_list' => :'contactList',
        
        :'queue' => :'queue',
        
        :'dialing_mode' => :'dialingMode',
        
        :'script' => :'script',
        
        :'edge_group' => :'edgeGroup',
        
        :'campaign_status' => :'campaignStatus',
        
        :'phone_columns' => :'phoneColumns',
        
        :'abandon_rate' => :'abandonRate',
        
        :'dnc_lists' => :'dncLists',
        
        :'callable_time_set' => :'callableTimeSet',
        
        :'call_analysis_response_set' => :'callAnalysisResponseSet',
        
        :'caller_name' => :'callerName',
        
        :'caller_address' => :'callerAddress',
        
        :'outbound_line_count' => :'outboundLineCount',
        
        :'errors' => :'errors',
        
        :'rule_sets' => :'ruleSets',
        
        :'skip_preview_disabled' => :'skipPreviewDisabled',
        
        :'preview_time_out_seconds' => :'previewTimeOutSeconds',
        
        :'single_number_preview' => :'singleNumberPreview',
        
        :'contact_sort' => :'contactSort',
        
        :'no_answer_timeout' => :'noAnswerTimeout',
        
        :'call_analysis_language' => :'callAnalysisLanguage',
        
        :'priority' => :'priority',
        
        :'additional_properties' => :'additionalProperties'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'id' => :'String',
        :'name' => :'String',
        :'date_created' => :'DateTime',
        :'date_modified' => :'DateTime',
        :'version' => :'Integer',
        :'contact_list' => :'DocumentDataV2NotificationCreatedBy',
        :'queue' => :'CampaignNotificationUriReference',
        :'dialing_mode' => :'String',
        :'script' => :'CampaignNotificationUriReference',
        :'edge_group' => :'CampaignNotificationUriReference',
        :'campaign_status' => :'String',
        :'phone_columns' => :'Array<CampaignNotificationPhoneColumns>',
        :'abandon_rate' => :'Float',
        :'dnc_lists' => :'Array<CampaignNotificationUriReference>',
        :'callable_time_set' => :'CampaignNotificationUriReference',
        :'call_analysis_response_set' => :'CampaignNotificationUriReference',
        :'caller_name' => :'String',
        :'caller_address' => :'String',
        :'outbound_line_count' => :'Integer',
        :'errors' => :'Array<CampaignNotificationErrors>',
        :'rule_sets' => :'Array<CampaignNotificationUriReference>',
        :'skip_preview_disabled' => :'BOOLEAN',
        :'preview_time_out_seconds' => :'Integer',
        :'single_number_preview' => :'BOOLEAN',
        :'contact_sort' => :'CampaignNotificationContactSort',
        :'no_answer_timeout' => :'Integer',
        :'call_analysis_language' => :'String',
        :'priority' => :'Integer',
        :'additional_properties' => :'Object'
        
      }
    end

    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'id']
        self.id = attributes[:'id']
      end
      
      if attributes[:'name']
        self.name = attributes[:'name']
      end
      
      if attributes[:'dateCreated']
        self.date_created = attributes[:'dateCreated']
      end
      
      if attributes[:'dateModified']
        self.date_modified = attributes[:'dateModified']
      end
      
      if attributes[:'version']
        self.version = attributes[:'version']
      end
      
      if attributes[:'contactList']
        self.contact_list = attributes[:'contactList']
      end
      
      if attributes[:'queue']
        self.queue = attributes[:'queue']
      end
      
      if attributes[:'dialingMode']
        self.dialing_mode = attributes[:'dialingMode']
      end
      
      if attributes[:'script']
        self.script = attributes[:'script']
      end
      
      if attributes[:'edgeGroup']
        self.edge_group = attributes[:'edgeGroup']
      end
      
      if attributes[:'campaignStatus']
        self.campaign_status = attributes[:'campaignStatus']
      end
      
      if attributes[:'phoneColumns']
        if (value = attributes[:'phoneColumns']).is_a?(Array)
          self.phone_columns = value
        end
      end
      
      if attributes[:'abandonRate']
        self.abandon_rate = attributes[:'abandonRate']
      end
      
      if attributes[:'dncLists']
        if (value = attributes[:'dncLists']).is_a?(Array)
          self.dnc_lists = value
        end
      end
      
      if attributes[:'callableTimeSet']
        self.callable_time_set = attributes[:'callableTimeSet']
      end
      
      if attributes[:'callAnalysisResponseSet']
        self.call_analysis_response_set = attributes[:'callAnalysisResponseSet']
      end
      
      if attributes[:'callerName']
        self.caller_name = attributes[:'callerName']
      end
      
      if attributes[:'callerAddress']
        self.caller_address = attributes[:'callerAddress']
      end
      
      if attributes[:'outboundLineCount']
        self.outbound_line_count = attributes[:'outboundLineCount']
      end
      
      if attributes[:'errors']
        if (value = attributes[:'errors']).is_a?(Array)
          self.errors = value
        end
      end
      
      if attributes[:'ruleSets']
        if (value = attributes[:'ruleSets']).is_a?(Array)
          self.rule_sets = value
        end
      end
      
      if attributes[:'skipPreviewDisabled']
        self.skip_preview_disabled = attributes[:'skipPreviewDisabled']
      end
      
      if attributes[:'previewTimeOutSeconds']
        self.preview_time_out_seconds = attributes[:'previewTimeOutSeconds']
      end
      
      if attributes[:'singleNumberPreview']
        self.single_number_preview = attributes[:'singleNumberPreview']
      end
      
      if attributes[:'contactSort']
        self.contact_sort = attributes[:'contactSort']
      end
      
      if attributes[:'noAnswerTimeout']
        self.no_answer_timeout = attributes[:'noAnswerTimeout']
      end
      
      if attributes[:'callAnalysisLanguage']
        self.call_analysis_language = attributes[:'callAnalysisLanguage']
      end
      
      if attributes[:'priority']
        self.priority = attributes[:'priority']
      end
      
      if attributes[:'additionalProperties']
        self.additional_properties = attributes[:'additionalProperties']
      end
      
    end

    # Custom attribute writer method checking allowed values (enum).
    def dialing_mode=(dialing_mode)
      allowed_values = ["AGENTLESS", "PREVIEW", "POWER", "PREDICTIVE", "PROGRESSIVE"]
      if dialing_mode && !allowed_values.include?(dialing_mode)
        fail "invalid value for 'dialing_mode', must be one of #{allowed_values}"
      end
      @dialing_mode = dialing_mode
    end

    # Custom attribute writer method checking allowed values (enum).
    def campaign_status=(campaign_status)
      allowed_values = ["ON", "OFF", "COMPLETE", "STOPPING", "INVALID"]
      if campaign_status && !allowed_values.include?(campaign_status)
        fail "invalid value for 'campaign_status', must be one of #{allowed_values}"
      end
      @campaign_status = campaign_status
    end

    # Check equality by comparing each attribute.
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          name == o.name &&
          date_created == o.date_created &&
          date_modified == o.date_modified &&
          version == o.version &&
          contact_list == o.contact_list &&
          queue == o.queue &&
          dialing_mode == o.dialing_mode &&
          script == o.script &&
          edge_group == o.edge_group &&
          campaign_status == o.campaign_status &&
          phone_columns == o.phone_columns &&
          abandon_rate == o.abandon_rate &&
          dnc_lists == o.dnc_lists &&
          callable_time_set == o.callable_time_set &&
          call_analysis_response_set == o.call_analysis_response_set &&
          caller_name == o.caller_name &&
          caller_address == o.caller_address &&
          outbound_line_count == o.outbound_line_count &&
          errors == o.errors &&
          rule_sets == o.rule_sets &&
          skip_preview_disabled == o.skip_preview_disabled &&
          preview_time_out_seconds == o.preview_time_out_seconds &&
          single_number_preview == o.single_number_preview &&
          contact_sort == o.contact_sort &&
          no_answer_timeout == o.no_answer_timeout &&
          call_analysis_language == o.call_analysis_language &&
          priority == o.priority &&
          additional_properties == o.additional_properties
    end

    # @see the `==` method
    def eql?(o)
      self == o
    end

    # Calculate hash code according to all attributes.
    def hash
      [id, name, date_created, date_modified, version, contact_list, queue, dialing_mode, script, edge_group, campaign_status, phone_columns, abandon_rate, dnc_lists, callable_time_set, call_analysis_response_set, caller_name, caller_address, outbound_line_count, errors, rule_sets, skip_preview_disabled, preview_time_out_seconds, single_number_preview, contact_sort, no_answer_timeout, call_analysis_language, priority, additional_properties].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
