=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@inin.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: ININ
http://www.inin.com

Terms of Service: https://developer.mypurecloud.com/tos

=end

require 'date'

module PureCloud
  class Condition
    # The type of the condition
    attr_accessor :type

    # Indicates whether to evaluate for the opposite of the stated condition; default is false
    attr_accessor :inverted

    # An attribute name associated with the condition (applies only to certain rule conditions)
    attr_accessor :attribute_name

    # A value associated with the condition
    attr_accessor :value

    # Determines the type of the value associated with the condition
    attr_accessor :value_type

    # An operation type for condition evaluation
    attr_accessor :operator

    # List of wrap-up code identifiers (used only in conditions of type 'wrapupCondition')
    attr_accessor :codes

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'type' => :'type',
        
        :'inverted' => :'inverted',
        
        :'attribute_name' => :'attributeName',
        
        :'value' => :'value',
        
        :'value_type' => :'valueType',
        
        :'operator' => :'operator',
        
        :'codes' => :'codes'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'type' => :'String',
        :'inverted' => :'BOOLEAN',
        :'attribute_name' => :'String',
        :'value' => :'String',
        :'value_type' => :'String',
        :'operator' => :'String',
        :'codes' => :'Array<String>'
        
      }
    end

    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'type']
        self.type = attributes[:'type']
      end
      
      if attributes[:'inverted']
        self.inverted = attributes[:'inverted']
      end
      
      if attributes[:'attributeName']
        self.attribute_name = attributes[:'attributeName']
      end
      
      if attributes[:'value']
        self.value = attributes[:'value']
      end
      
      if attributes[:'valueType']
        self.value_type = attributes[:'valueType']
      end
      
      if attributes[:'operator']
        self.operator = attributes[:'operator']
      end
      
      if attributes[:'codes']
        if (value = attributes[:'codes']).is_a?(Array)
          self.codes = value
        end
      end
      
    end

    # Custom attribute writer method checking allowed values (enum).
    def type=(type)
      allowed_values = ["wrapupCondition", "contactAttributeCondition", "phoneNumberCondition", "phoneNumberTypeCondition", "callAnalysisCondition"]
      if type && !allowed_values.include?(type)
        fail "invalid value for 'type', must be one of #{allowed_values}"
      end
      @type = type
    end

    # Custom attribute writer method checking allowed values (enum).
    def value_type=(value_type)
      allowed_values = ["STRING", "NUMERIC", "DATETIME", "PERIOD"]
      if value_type && !allowed_values.include?(value_type)
        fail "invalid value for 'value_type', must be one of #{allowed_values}"
      end
      @value_type = value_type
    end

    # Custom attribute writer method checking allowed values (enum).
    def operator=(operator)
      allowed_values = ["EQUALS", "LESS_THAN", "LESS_THAN_EQUALS", "GREATER_THAN", "GREATER_THAN_EQUALS", "CONTAINS", "BEGINS_WITH", "ENDS_WITH", "BEFORE", "AFTER"]
      if operator && !allowed_values.include?(operator)
        fail "invalid value for 'operator', must be one of #{allowed_values}"
      end
      @operator = operator
    end

    # Check equality by comparing each attribute.
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          type == o.type &&
          inverted == o.inverted &&
          attribute_name == o.attribute_name &&
          value == o.value &&
          value_type == o.value_type &&
          operator == o.operator &&
          codes == o.codes
    end

    # @see the `==` method
    def eql?(o)
      self == o
    end

    # Calculate hash code according to all attributes.
    def hash
      [type, inverted, attribute_name, value, value_type, operator, codes].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
