=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@inin.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: ININ
http://www.inin.com

Terms of Service: https://developer.mypurecloud.com/tos

=end

require 'date'

module PureCloud
  class ConversationNotificationCall
    attr_accessor :id

    attr_accessor :state

    attr_accessor :recording

    attr_accessor :recording_state

    attr_accessor :muted

    attr_accessor :confined

    attr_accessor :held

    attr_accessor :error_info

    attr_accessor :disconnect_type

    attr_accessor :start_hold_time

    attr_accessor :direction

    attr_accessor :document_id

    attr_accessor :_self

    attr_accessor :other

    attr_accessor :provider

    attr_accessor :connected_time

    attr_accessor :disconnected_time

    attr_accessor :disconnect_reasons

    attr_accessor :fax_status

    attr_accessor :additional_properties

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'id' => :'id',
        
        :'state' => :'state',
        
        :'recording' => :'recording',
        
        :'recording_state' => :'recordingState',
        
        :'muted' => :'muted',
        
        :'confined' => :'confined',
        
        :'held' => :'held',
        
        :'error_info' => :'errorInfo',
        
        :'disconnect_type' => :'disconnectType',
        
        :'start_hold_time' => :'startHoldTime',
        
        :'direction' => :'direction',
        
        :'document_id' => :'documentId',
        
        :'_self' => :'self',
        
        :'other' => :'other',
        
        :'provider' => :'provider',
        
        :'connected_time' => :'connectedTime',
        
        :'disconnected_time' => :'disconnectedTime',
        
        :'disconnect_reasons' => :'disconnectReasons',
        
        :'fax_status' => :'faxStatus',
        
        :'additional_properties' => :'additionalProperties'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'id' => :'String',
        :'state' => :'String',
        :'recording' => :'BOOLEAN',
        :'recording_state' => :'String',
        :'muted' => :'BOOLEAN',
        :'confined' => :'BOOLEAN',
        :'held' => :'BOOLEAN',
        :'error_info' => :'ConversationNotificationErrorInfo',
        :'disconnect_type' => :'String',
        :'start_hold_time' => :'DateTime',
        :'direction' => :'String',
        :'document_id' => :'String',
        :'_self' => :'ConversationNotificationSelf',
        :'other' => :'ConversationNotificationAddress',
        :'provider' => :'String',
        :'connected_time' => :'DateTime',
        :'disconnected_time' => :'DateTime',
        :'disconnect_reasons' => :'Array<ConversationNotificationDisconnectReasons>',
        :'fax_status' => :'ConversationNotificationFaxStatus',
        :'additional_properties' => :'Object'
        
      }
    end

    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'id']
        self.id = attributes[:'id']
      end
      
      if attributes[:'state']
        self.state = attributes[:'state']
      end
      
      if attributes[:'recording']
        self.recording = attributes[:'recording']
      end
      
      if attributes[:'recordingState']
        self.recording_state = attributes[:'recordingState']
      end
      
      if attributes[:'muted']
        self.muted = attributes[:'muted']
      end
      
      if attributes[:'confined']
        self.confined = attributes[:'confined']
      end
      
      if attributes[:'held']
        self.held = attributes[:'held']
      end
      
      if attributes[:'errorInfo']
        self.error_info = attributes[:'errorInfo']
      end
      
      if attributes[:'disconnectType']
        self.disconnect_type = attributes[:'disconnectType']
      end
      
      if attributes[:'startHoldTime']
        self.start_hold_time = attributes[:'startHoldTime']
      end
      
      if attributes[:'direction']
        self.direction = attributes[:'direction']
      end
      
      if attributes[:'documentId']
        self.document_id = attributes[:'documentId']
      end
      
      if attributes[:'self']
        self._self = attributes[:'self']
      end
      
      if attributes[:'other']
        self.other = attributes[:'other']
      end
      
      if attributes[:'provider']
        self.provider = attributes[:'provider']
      end
      
      if attributes[:'connectedTime']
        self.connected_time = attributes[:'connectedTime']
      end
      
      if attributes[:'disconnectedTime']
        self.disconnected_time = attributes[:'disconnectedTime']
      end
      
      if attributes[:'disconnectReasons']
        if (value = attributes[:'disconnectReasons']).is_a?(Array)
          self.disconnect_reasons = value
        end
      end
      
      if attributes[:'faxStatus']
        self.fax_status = attributes[:'faxStatus']
      end
      
      if attributes[:'additionalProperties']
        self.additional_properties = attributes[:'additionalProperties']
      end
      
    end

    # Custom attribute writer method checking allowed values (enum).
    def state=(state)
      allowed_values = ["ALERTING", "DIALING", "CONTACTING", "OFFERING", "CONNECTED", "DISCONNECTED", "TERMINATED", "UPLOADING", "CONVERTING", "TRANSMITTING", "NONE"]
      if state && !allowed_values.include?(state)
        fail "invalid value for 'state', must be one of #{allowed_values}"
      end
      @state = state
    end

    # Custom attribute writer method checking allowed values (enum).
    def recording_state=(recording_state)
      allowed_values = ["NONE", "ACTIVE", "PAUSED"]
      if recording_state && !allowed_values.include?(recording_state)
        fail "invalid value for 'recording_state', must be one of #{allowed_values}"
      end
      @recording_state = recording_state
    end

    # Custom attribute writer method checking allowed values (enum).
    def disconnect_type=(disconnect_type)
      allowed_values = ["ENDPOINT", "CLIENT", "SYSTEM", "TIMEOUT", "TRANSFER", "TRANSFER_CONFERENCE", "TRANSFER_CONSULT", "TRANSFER_FORWARD", "TRANSFER_NOANSWER", "TRANSFER_NOTAVAILABLE", "TRANSPORT_FAILURE", "ERROR", "PEER", "OTHER", "SPAM", "UNCALLABLE"]
      if disconnect_type && !allowed_values.include?(disconnect_type)
        fail "invalid value for 'disconnect_type', must be one of #{allowed_values}"
      end
      @disconnect_type = disconnect_type
    end

    # Custom attribute writer method checking allowed values (enum).
    def direction=(direction)
      allowed_values = ["OUTBOUND", "INBOUND"]
      if direction && !allowed_values.include?(direction)
        fail "invalid value for 'direction', must be one of #{allowed_values}"
      end
      @direction = direction
    end

    # Check equality by comparing each attribute.
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          state == o.state &&
          recording == o.recording &&
          recording_state == o.recording_state &&
          muted == o.muted &&
          confined == o.confined &&
          held == o.held &&
          error_info == o.error_info &&
          disconnect_type == o.disconnect_type &&
          start_hold_time == o.start_hold_time &&
          direction == o.direction &&
          document_id == o.document_id &&
          _self == o._self &&
          other == o.other &&
          provider == o.provider &&
          connected_time == o.connected_time &&
          disconnected_time == o.disconnected_time &&
          disconnect_reasons == o.disconnect_reasons &&
          fax_status == o.fax_status &&
          additional_properties == o.additional_properties
    end

    # @see the `==` method
    def eql?(o)
      self == o
    end

    # Calculate hash code according to all attributes.
    def hash
      [id, state, recording, recording_state, muted, confined, held, error_info, disconnect_type, start_hold_time, direction, document_id, _self, other, provider, connected_time, disconnected_time, disconnect_reasons, fax_status, additional_properties].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
