=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@inin.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: ININ
http://www.inin.com

Terms of Service: https://developer.mypurecloud.com/tos

=end

require 'date'

module PureCloud
  class DocumentAudit
    # The globally unique identifier for the object.
    attr_accessor :id

    attr_accessor :name

    attr_accessor :user

    attr_accessor :workspace

    attr_accessor :transaction_id

    attr_accessor :transaction_initiator

    attr_accessor :application

    attr_accessor :service_name

    attr_accessor :level

    # Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ
    attr_accessor :timestamp

    attr_accessor :status

    attr_accessor :action_context

    attr_accessor :action

    attr_accessor :entity

    attr_accessor :changes

    # The URI for this object
    attr_accessor :self_uri

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'id' => :'id',
        
        :'name' => :'name',
        
        :'user' => :'user',
        
        :'workspace' => :'workspace',
        
        :'transaction_id' => :'transactionId',
        
        :'transaction_initiator' => :'transactionInitiator',
        
        :'application' => :'application',
        
        :'service_name' => :'serviceName',
        
        :'level' => :'level',
        
        :'timestamp' => :'timestamp',
        
        :'status' => :'status',
        
        :'action_context' => :'actionContext',
        
        :'action' => :'action',
        
        :'entity' => :'entity',
        
        :'changes' => :'changes',
        
        :'self_uri' => :'selfUri'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'id' => :'String',
        :'name' => :'String',
        :'user' => :'UriReference',
        :'workspace' => :'UriReference',
        :'transaction_id' => :'String',
        :'transaction_initiator' => :'BOOLEAN',
        :'application' => :'String',
        :'service_name' => :'String',
        :'level' => :'String',
        :'timestamp' => :'DateTime',
        :'status' => :'String',
        :'action_context' => :'String',
        :'action' => :'String',
        :'entity' => :'AuditEntityReference',
        :'changes' => :'Array<AuditChange>',
        :'self_uri' => :'String'
        
      }
    end

    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'id']
        self.id = attributes[:'id']
      end
      
      if attributes[:'name']
        self.name = attributes[:'name']
      end
      
      if attributes[:'user']
        self.user = attributes[:'user']
      end
      
      if attributes[:'workspace']
        self.workspace = attributes[:'workspace']
      end
      
      if attributes[:'transactionId']
        self.transaction_id = attributes[:'transactionId']
      end
      
      if attributes[:'transactionInitiator']
        self.transaction_initiator = attributes[:'transactionInitiator']
      end
      
      if attributes[:'application']
        self.application = attributes[:'application']
      end
      
      if attributes[:'serviceName']
        self.service_name = attributes[:'serviceName']
      end
      
      if attributes[:'level']
        self.level = attributes[:'level']
      end
      
      if attributes[:'timestamp']
        self.timestamp = attributes[:'timestamp']
      end
      
      if attributes[:'status']
        self.status = attributes[:'status']
      end
      
      if attributes[:'actionContext']
        self.action_context = attributes[:'actionContext']
      end
      
      if attributes[:'action']
        self.action = attributes[:'action']
      end
      
      if attributes[:'entity']
        self.entity = attributes[:'entity']
      end
      
      if attributes[:'changes']
        if (value = attributes[:'changes']).is_a?(Array)
          self.changes = value
        end
      end
      
      if attributes[:'selfUri']
        self.self_uri = attributes[:'selfUri']
      end
      
    end

    # Custom attribute writer method checking allowed values (enum).
    def level=(level)
      allowed_values = ["USER", "SYSTEM"]
      if level && !allowed_values.include?(level)
        fail "invalid value for 'level', must be one of #{allowed_values}"
      end
      @level = level
    end

    # Custom attribute writer method checking allowed values (enum).
    def status=(status)
      allowed_values = ["SUCCESS", "FAILURE"]
      if status && !allowed_values.include?(status)
        fail "invalid value for 'status', must be one of #{allowed_values}"
      end
      @status = status
    end

    # Custom attribute writer method checking allowed values (enum).
    def action_context=(action_context)
      allowed_values = ["CREATE", "READ", "UPDATE", "DELETE", "DOWNLOAD", "VIEW", "UPLOAD", "SAVE", "MOVE", "COPY", "ADD", "REMOVE", "RECEIVE", "CONVERT", "FAX", "CREATE_COVERPAGE", "USER_ADD", "USER_REMOVE", "MEMBER_ADD", "MEMBER_REMOVE", "MEMBER_UPDATE", "TAG_ADD", "TAG_REMOVE", "TAG_UPDATE", "ATTRIBUTE_ADD", "ATTRIBUTE_REMOVE", "ATTRIBUTE_UPDATE", "ATTRIBUTE_GROUP_INSTANCE_ADD", "ATTRIBUTE_GROUP_INSTANCE_REMOVE", "ATTRIBUTE_GROUP_INSTANCE_UPDATE", "INDEX_SAVE", "INDEX_DELETE", "INDEX_CREATE", "FILE_SAVE", "FILE_DELETE", "FILE_READ", "THUMBNAIL_CREATE", "TEXT_EXTRACT", "SHARE_ADD", "SHARE_REMOVE", "VERSION_CREATE"]
      if action_context && !allowed_values.include?(action_context)
        fail "invalid value for 'action_context', must be one of #{allowed_values}"
      end
      @action_context = action_context
    end

    # Custom attribute writer method checking allowed values (enum).
    def action=(action)
      allowed_values = ["CREATE", "READ", "UPDATE", "DELETE", "DOWNLOAD", "VIEW", "UPLOAD", "SAVE", "MOVE", "COPY", "ADD", "REMOVE", "RECEIVE", "CONVERT", "FAX", "CREATE_COVERPAGE", "USER_ADD", "USER_REMOVE", "MEMBER_ADD", "MEMBER_REMOVE", "MEMBER_UPDATE", "TAG_ADD", "TAG_REMOVE", "TAG_UPDATE", "ATTRIBUTE_ADD", "ATTRIBUTE_REMOVE", "ATTRIBUTE_UPDATE", "ATTRIBUTE_GROUP_INSTANCE_ADD", "ATTRIBUTE_GROUP_INSTANCE_REMOVE", "ATTRIBUTE_GROUP_INSTANCE_UPDATE", "INDEX_SAVE", "INDEX_DELETE", "INDEX_CREATE", "FILE_SAVE", "FILE_DELETE", "FILE_READ", "THUMBNAIL_CREATE", "TEXT_EXTRACT", "SHARE_ADD", "SHARE_REMOVE", "VERSION_CREATE"]
      if action && !allowed_values.include?(action)
        fail "invalid value for 'action', must be one of #{allowed_values}"
      end
      @action = action
    end

    # Check equality by comparing each attribute.
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          name == o.name &&
          user == o.user &&
          workspace == o.workspace &&
          transaction_id == o.transaction_id &&
          transaction_initiator == o.transaction_initiator &&
          application == o.application &&
          service_name == o.service_name &&
          level == o.level &&
          timestamp == o.timestamp &&
          status == o.status &&
          action_context == o.action_context &&
          action == o.action &&
          entity == o.entity &&
          changes == o.changes &&
          self_uri == o.self_uri
    end

    # @see the `==` method
    def eql?(o)
      self == o
    end

    # Calculate hash code according to all attributes.
    def hash
      [id, name, user, workspace, transaction_id, transaction_initiator, application, service_name, level, timestamp, status, action_context, action, entity, changes, self_uri].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
