=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@inin.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: ININ
http://www.inin.com

Terms of Service: https://developer.mypurecloud.com/tos

=end

require 'date'

module PureCloud
  class HeartBeatAlert
    # The globally unique identifier for the object.
    attr_accessor :id

    # Name of the rule
    attr_accessor :name

    # The value that identifies the sender of the heartbeat.
    attr_accessor :sender_id

    # The number of minutes to wait before alerting missing heartbeats.
    attr_accessor :heart_beat_timeout_in_minutes

    # The id of the rule.
    attr_accessor :rule_id

    # The date/time the alert was created. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ
    attr_accessor :start_date

    # The date/time the owning rule exiting in alarm status. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ
    attr_accessor :end_date

    # The ids of users who were notified of alarm state change.
    attr_accessor :notification_users

    # A collection of notification methods.
    attr_accessor :alert_types

    # The type of heartbeat rule that generated the alert
    attr_accessor :rule_type

    attr_accessor :rule_uri

    # The URI for this object
    attr_accessor :self_uri

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'id' => :'id',
        
        :'name' => :'name',
        
        :'sender_id' => :'senderId',
        
        :'heart_beat_timeout_in_minutes' => :'heartBeatTimeoutInMinutes',
        
        :'rule_id' => :'ruleId',
        
        :'start_date' => :'startDate',
        
        :'end_date' => :'endDate',
        
        :'notification_users' => :'notificationUsers',
        
        :'alert_types' => :'alertTypes',
        
        :'rule_type' => :'ruleType',
        
        :'rule_uri' => :'ruleUri',
        
        :'self_uri' => :'selfUri'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'id' => :'String',
        :'name' => :'String',
        :'sender_id' => :'String',
        :'heart_beat_timeout_in_minutes' => :'Integer',
        :'rule_id' => :'String',
        :'start_date' => :'DateTime',
        :'end_date' => :'DateTime',
        :'notification_users' => :'Array<User>',
        :'alert_types' => :'Array<String>',
        :'rule_type' => :'String',
        :'rule_uri' => :'String',
        :'self_uri' => :'String'
        
      }
    end

    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'id']
        self.id = attributes[:'id']
      end
      
      if attributes[:'name']
        self.name = attributes[:'name']
      end
      
      if attributes[:'senderId']
        self.sender_id = attributes[:'senderId']
      end
      
      if attributes[:'heartBeatTimeoutInMinutes']
        self.heart_beat_timeout_in_minutes = attributes[:'heartBeatTimeoutInMinutes']
      end
      
      if attributes[:'ruleId']
        self.rule_id = attributes[:'ruleId']
      end
      
      if attributes[:'startDate']
        self.start_date = attributes[:'startDate']
      end
      
      if attributes[:'endDate']
        self.end_date = attributes[:'endDate']
      end
      
      if attributes[:'notificationUsers']
        if (value = attributes[:'notificationUsers']).is_a?(Array)
          self.notification_users = value
        end
      end
      
      if attributes[:'alertTypes']
        if (value = attributes[:'alertTypes']).is_a?(Array)
          self.alert_types = value
        end
      end
      
      if attributes[:'ruleType']
        self.rule_type = attributes[:'ruleType']
      end
      
      if attributes[:'ruleUri']
        self.rule_uri = attributes[:'ruleUri']
      end
      
      if attributes[:'selfUri']
        self.self_uri = attributes[:'selfUri']
      end
      
    end

    # Custom attribute writer method checking allowed values (enum).
    def rule_type=(rule_type)
      allowed_values = ["EDGE"]
      if rule_type && !allowed_values.include?(rule_type)
        fail "invalid value for 'rule_type', must be one of #{allowed_values}"
      end
      @rule_type = rule_type
    end

    # Check equality by comparing each attribute.
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          name == o.name &&
          sender_id == o.sender_id &&
          heart_beat_timeout_in_minutes == o.heart_beat_timeout_in_minutes &&
          rule_id == o.rule_id &&
          start_date == o.start_date &&
          end_date == o.end_date &&
          notification_users == o.notification_users &&
          alert_types == o.alert_types &&
          rule_type == o.rule_type &&
          rule_uri == o.rule_uri &&
          self_uri == o.self_uri
    end

    # @see the `==` method
    def eql?(o)
      self == o
    end

    # Calculate hash code according to all attributes.
    def hash
      [id, name, sender_id, heart_beat_timeout_in_minutes, rule_id, start_date, end_date, notification_users, alert_types, rule_type, rule_uri, self_uri].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
