=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@inin.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: ININ
http://www.inin.com

Terms of Service: https://developer.mypurecloud.com/tos

=end

require 'date'

module PureCloud
  class PhoneStatus
    # The globally unique identifier for the object.
    attr_accessor :id

    attr_accessor :name

    # The Operational Status of this phone
    attr_accessor :operational_status

    # The status of the primary or secondary Edges assigned to the phone lines.
    attr_accessor :edges_status

    # Event Creation Time represents an ISO-8601 string. For example: UTC, UTC+01:00, or Europe/London
    attr_accessor :event_creation_time

    # Provision information for this phone
    attr_accessor :provision

    # A list of LineStatus information for each of the lines of this phone
    attr_accessor :line_statuses

    # The phone status's edge assignment type.
    attr_accessor :phone_assignment_to_edge_type

    # The URI of the edge that provided this status information.
    attr_accessor :edge

    # The URI for this object
    attr_accessor :self_uri

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'id' => :'id',
        
        :'name' => :'name',
        
        :'operational_status' => :'operationalStatus',
        
        :'edges_status' => :'edgesStatus',
        
        :'event_creation_time' => :'eventCreationTime',
        
        :'provision' => :'provision',
        
        :'line_statuses' => :'lineStatuses',
        
        :'phone_assignment_to_edge_type' => :'phoneAssignmentToEdgeType',
        
        :'edge' => :'edge',
        
        :'self_uri' => :'selfUri'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'id' => :'String',
        :'name' => :'String',
        :'operational_status' => :'String',
        :'edges_status' => :'String',
        :'event_creation_time' => :'String',
        :'provision' => :'ProvisionInfo',
        :'line_statuses' => :'Array<LineStatus>',
        :'phone_assignment_to_edge_type' => :'String',
        :'edge' => :'UriReference',
        :'self_uri' => :'String'
        
      }
    end

    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'id']
        self.id = attributes[:'id']
      end
      
      if attributes[:'name']
        self.name = attributes[:'name']
      end
      
      if attributes[:'operationalStatus']
        self.operational_status = attributes[:'operationalStatus']
      end
      
      if attributes[:'edgesStatus']
        self.edges_status = attributes[:'edgesStatus']
      end
      
      if attributes[:'eventCreationTime']
        self.event_creation_time = attributes[:'eventCreationTime']
      end
      
      if attributes[:'provision']
        self.provision = attributes[:'provision']
      end
      
      if attributes[:'lineStatuses']
        if (value = attributes[:'lineStatuses']).is_a?(Array)
          self.line_statuses = value
        end
      end
      
      if attributes[:'phoneAssignmentToEdgeType']
        self.phone_assignment_to_edge_type = attributes[:'phoneAssignmentToEdgeType']
      end
      
      if attributes[:'edge']
        self.edge = attributes[:'edge']
      end
      
      if attributes[:'selfUri']
        self.self_uri = attributes[:'selfUri']
      end
      
    end

    # Custom attribute writer method checking allowed values (enum).
    def operational_status=(operational_status)
      allowed_values = ["OPERATIONAL", "DEGRADED", "OFFLINE"]
      if operational_status && !allowed_values.include?(operational_status)
        fail "invalid value for 'operational_status', must be one of #{allowed_values}"
      end
      @operational_status = operational_status
    end

    # Custom attribute writer method checking allowed values (enum).
    def edges_status=(edges_status)
      allowed_values = ["IN_SERVICE", "MIXED_SERVICE", "OUT_OF_SERVICE", "NO_EDGES"]
      if edges_status && !allowed_values.include?(edges_status)
        fail "invalid value for 'edges_status', must be one of #{allowed_values}"
      end
      @edges_status = edges_status
    end

    # Custom attribute writer method checking allowed values (enum).
    def phone_assignment_to_edge_type=(phone_assignment_to_edge_type)
      allowed_values = ["PRIMARY", "SECONDARY"]
      if phone_assignment_to_edge_type && !allowed_values.include?(phone_assignment_to_edge_type)
        fail "invalid value for 'phone_assignment_to_edge_type', must be one of #{allowed_values}"
      end
      @phone_assignment_to_edge_type = phone_assignment_to_edge_type
    end

    # Check equality by comparing each attribute.
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          name == o.name &&
          operational_status == o.operational_status &&
          edges_status == o.edges_status &&
          event_creation_time == o.event_creation_time &&
          provision == o.provision &&
          line_statuses == o.line_statuses &&
          phone_assignment_to_edge_type == o.phone_assignment_to_edge_type &&
          edge == o.edge &&
          self_uri == o.self_uri
    end

    # @see the `==` method
    def eql?(o)
      self == o
    end

    # Calculate hash code according to all attributes.
    def hash
      [id, name, operational_status, edges_status, event_creation_time, provision, line_statuses, phone_assignment_to_edge_type, edge, self_uri].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
