=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@inin.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: ININ
http://www.inin.com

Terms of Service: https://developer.mypurecloud.com/tos

=end

require "uri"

module PureCloud
  class OutboundApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # Delete attempt limits
    # 
    # @param attempt_limits_id Attempt limits ID
    # @param [Hash] opts the optional parameters
    # @return [String]
    def delete_attemptlimits_attemptlimits_id(attempt_limits_id, opts = {})
      data, status_code, headers = delete_attemptlimits_attemptlimits_id_with_http_info(attempt_limits_id, opts)
      return data
    end

    # Delete attempt limits
    # 
    # @param attempt_limits_id Attempt limits ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def delete_attemptlimits_attemptlimits_id_with_http_info(attempt_limits_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#delete_attemptlimits_attemptlimits_id ..."
      end
      
      # verify the required parameter 'attempt_limits_id' is set
      fail "Missing the required parameter 'attempt_limits_id' when calling delete_attemptlimits_attemptlimits_id" if attempt_limits_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/attemptlimits/{attemptLimitsId}".sub('{format}','json').sub('{' + 'attemptLimitsId' + '}', attempt_limits_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#delete_attemptlimits_attemptlimits_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete callable time set
    # 
    # @param callable_time_set_id Callable Time Set ID
    # @param [Hash] opts the optional parameters
    # @return [String]
    def delete_callabletimesets_callabletimeset_id(callable_time_set_id, opts = {})
      data, status_code, headers = delete_callabletimesets_callabletimeset_id_with_http_info(callable_time_set_id, opts)
      return data
    end

    # Delete callable time set
    # 
    # @param callable_time_set_id Callable Time Set ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def delete_callabletimesets_callabletimeset_id_with_http_info(callable_time_set_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#delete_callabletimesets_callabletimeset_id ..."
      end
      
      # verify the required parameter 'callable_time_set_id' is set
      fail "Missing the required parameter 'callable_time_set_id' when calling delete_callabletimesets_callabletimeset_id" if callable_time_set_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/callabletimesets/{callableTimeSetId}".sub('{format}','json').sub('{' + 'callableTimeSetId' + '}', callable_time_set_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#delete_callabletimesets_callabletimeset_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a dialer call analysis response set.
    # 
    # @param call_analysis_set_id Call Analysis Response Set ID
    # @param [Hash] opts the optional parameters
    # @return [String]
    def delete_callanalysisresponsesets_callanalysisset_id(call_analysis_set_id, opts = {})
      data, status_code, headers = delete_callanalysisresponsesets_callanalysisset_id_with_http_info(call_analysis_set_id, opts)
      return data
    end

    # Delete a dialer call analysis response set.
    # 
    # @param call_analysis_set_id Call Analysis Response Set ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def delete_callanalysisresponsesets_callanalysisset_id_with_http_info(call_analysis_set_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#delete_callanalysisresponsesets_callanalysisset_id ..."
      end
      
      # verify the required parameter 'call_analysis_set_id' is set
      fail "Missing the required parameter 'call_analysis_set_id' when calling delete_callanalysisresponsesets_callanalysisset_id" if call_analysis_set_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/callanalysisresponsesets/{callAnalysisSetId}".sub('{format}','json').sub('{' + 'callAnalysisSetId' + '}', call_analysis_set_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#delete_callanalysisresponsesets_callanalysisset_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete Campaign Rule
    # 
    # @param campaign_rule_id Campaign Rule ID
    # @param [Hash] opts the optional parameters
    # @return [String]
    def delete_campaignrules_campaignrule_id(campaign_rule_id, opts = {})
      data, status_code, headers = delete_campaignrules_campaignrule_id_with_http_info(campaign_rule_id, opts)
      return data
    end

    # Delete Campaign Rule
    # 
    # @param campaign_rule_id Campaign Rule ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def delete_campaignrules_campaignrule_id_with_http_info(campaign_rule_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#delete_campaignrules_campaignrule_id ..."
      end
      
      # verify the required parameter 'campaign_rule_id' is set
      fail "Missing the required parameter 'campaign_rule_id' when calling delete_campaignrules_campaignrule_id" if campaign_rule_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/campaignrules/{campaignRuleId}".sub('{format}','json').sub('{' + 'campaignRuleId' + '}', campaign_rule_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#delete_campaignrules_campaignrule_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a campaign.
    # 
    # @param campaign_id Campaign ID
    # @param [Hash] opts the optional parameters
    # @return [Campaign]
    def delete_campaigns_campaign_id(campaign_id, opts = {})
      data, status_code, headers = delete_campaigns_campaign_id_with_http_info(campaign_id, opts)
      return data
    end

    # Delete a campaign.
    # 
    # @param campaign_id Campaign ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(Campaign, Fixnum, Hash)>] Campaign data, response status code and response headers
    def delete_campaigns_campaign_id_with_http_info(campaign_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#delete_campaigns_campaign_id ..."
      end
      
      # verify the required parameter 'campaign_id' is set
      fail "Missing the required parameter 'campaign_id' when calling delete_campaigns_campaign_id" if campaign_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/campaigns/{campaignId}".sub('{format}','json').sub('{' + 'campaignId' + '}', campaign_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Campaign')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#delete_campaigns_campaign_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Reset campaign progress and recycle the campaign
    # 
    # @param campaign_id Campaign ID
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_campaigns_campaign_id_progress(campaign_id, opts = {})
      delete_campaigns_campaign_id_progress_with_http_info(campaign_id, opts)
      return nil
    end

    # Reset campaign progress and recycle the campaign
    # 
    # @param campaign_id Campaign ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_campaigns_campaign_id_progress_with_http_info(campaign_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#delete_campaigns_campaign_id_progress ..."
      end
      
      # verify the required parameter 'campaign_id' is set
      fail "Missing the required parameter 'campaign_id' when calling delete_campaigns_campaign_id_progress" if campaign_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/campaigns/{campaignId}/progress".sub('{format}','json').sub('{' + 'campaignId' + '}', campaign_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#delete_campaigns_campaign_id_progress\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a contact list.
    # 
    # @param contact_list_id ContactList ID
    # @param [Hash] opts the optional parameters
    # @return [String]
    def delete_contactlists_contactlist_id(contact_list_id, opts = {})
      data, status_code, headers = delete_contactlists_contactlist_id_with_http_info(contact_list_id, opts)
      return data
    end

    # Delete a contact list.
    # 
    # @param contact_list_id ContactList ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def delete_contactlists_contactlist_id_with_http_info(contact_list_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#delete_contactlists_contactlist_id ..."
      end
      
      # verify the required parameter 'contact_list_id' is set
      fail "Missing the required parameter 'contact_list_id' when calling delete_contactlists_contactlist_id" if contact_list_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/contactlists/{contactListId}".sub('{format}','json').sub('{' + 'contactListId' + '}', contact_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#delete_contactlists_contactlist_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a contact.
    # 
    # @param contact_list_id Contact List ID
    # @param contact_id Contact ID
    # @param [Hash] opts the optional parameters
    # @return [String]
    def delete_contactlists_contactlist_id_contacts_contact_id(contact_list_id, contact_id, opts = {})
      data, status_code, headers = delete_contactlists_contactlist_id_contacts_contact_id_with_http_info(contact_list_id, contact_id, opts)
      return data
    end

    # Delete a contact.
    # 
    # @param contact_list_id Contact List ID
    # @param contact_id Contact ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def delete_contactlists_contactlist_id_contacts_contact_id_with_http_info(contact_list_id, contact_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#delete_contactlists_contactlist_id_contacts_contact_id ..."
      end
      
      # verify the required parameter 'contact_list_id' is set
      fail "Missing the required parameter 'contact_list_id' when calling delete_contactlists_contactlist_id_contacts_contact_id" if contact_list_id.nil?
      
      # verify the required parameter 'contact_id' is set
      fail "Missing the required parameter 'contact_id' when calling delete_contactlists_contactlist_id_contacts_contact_id" if contact_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/contactlists/{contactListId}/contacts/{contactId}".sub('{format}','json').sub('{' + 'contactListId' + '}', contact_list_id.to_s).sub('{' + 'contactId' + '}', contact_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#delete_contactlists_contactlist_id_contacts_contact_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete dialer DNC list
    # 
    # @param dnc_list_id DncList ID
    # @param [Hash] opts the optional parameters
    # @return [String]
    def delete_dnclists_dnclist_id(dnc_list_id, opts = {})
      data, status_code, headers = delete_dnclists_dnclist_id_with_http_info(dnc_list_id, opts)
      return data
    end

    # Delete dialer DNC list
    # 
    # @param dnc_list_id DncList ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def delete_dnclists_dnclist_id_with_http_info(dnc_list_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#delete_dnclists_dnclist_id ..."
      end
      
      # verify the required parameter 'dnc_list_id' is set
      fail "Missing the required parameter 'dnc_list_id' when calling delete_dnclists_dnclist_id" if dnc_list_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/dnclists/{dncListId}".sub('{format}','json').sub('{' + 'dncListId' + '}', dnc_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#delete_dnclists_dnclist_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a Rule set.
    # 
    # @param rule_set_id Rule Set ID
    # @param [Hash] opts the optional parameters
    # @return [String]
    def delete_rulesets_ruleset_id(rule_set_id, opts = {})
      data, status_code, headers = delete_rulesets_ruleset_id_with_http_info(rule_set_id, opts)
      return data
    end

    # Delete a Rule set.
    # 
    # @param rule_set_id Rule Set ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def delete_rulesets_ruleset_id_with_http_info(rule_set_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#delete_rulesets_ruleset_id ..."
      end
      
      # verify the required parameter 'rule_set_id' is set
      fail "Missing the required parameter 'rule_set_id' when calling delete_rulesets_ruleset_id" if rule_set_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/rulesets/{ruleSetId}".sub('{format}','json').sub('{' + 'ruleSetId' + '}', rule_set_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#delete_rulesets_ruleset_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a dialer campaign schedule.
    # 
    # @param campaign_id Campaign ID
    # @param [Hash] opts the optional parameters
    # @return [String]
    def delete_schedules_campaigns_campaign_id(campaign_id, opts = {})
      data, status_code, headers = delete_schedules_campaigns_campaign_id_with_http_info(campaign_id, opts)
      return data
    end

    # Delete a dialer campaign schedule.
    # 
    # @param campaign_id Campaign ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def delete_schedules_campaigns_campaign_id_with_http_info(campaign_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#delete_schedules_campaigns_campaign_id ..."
      end
      
      # verify the required parameter 'campaign_id' is set
      fail "Missing the required parameter 'campaign_id' when calling delete_schedules_campaigns_campaign_id" if campaign_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/schedules/campaigns/{campaignId}".sub('{format}','json').sub('{' + 'campaignId' + '}', campaign_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#delete_schedules_campaigns_campaign_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a dialer sequence schedule.
    # 
    # @param sequence_id Sequence ID
    # @param [Hash] opts the optional parameters
    # @return [String]
    def delete_schedules_sequences_sequence_id(sequence_id, opts = {})
      data, status_code, headers = delete_schedules_sequences_sequence_id_with_http_info(sequence_id, opts)
      return data
    end

    # Delete a dialer sequence schedule.
    # 
    # @param sequence_id Sequence ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def delete_schedules_sequences_sequence_id_with_http_info(sequence_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#delete_schedules_sequences_sequence_id ..."
      end
      
      # verify the required parameter 'sequence_id' is set
      fail "Missing the required parameter 'sequence_id' when calling delete_schedules_sequences_sequence_id" if sequence_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/schedules/sequences/{sequenceId}".sub('{format}','json').sub('{' + 'sequenceId' + '}', sequence_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#delete_schedules_sequences_sequence_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a dialer campaign sequence.
    # 
    # @param sequence_id Campaign Sequence ID
    # @param [Hash] opts the optional parameters
    # @return [String]
    def delete_sequences_sequence_id(sequence_id, opts = {})
      data, status_code, headers = delete_sequences_sequence_id_with_http_info(sequence_id, opts)
      return data
    end

    # Delete a dialer campaign sequence.
    # 
    # @param sequence_id Campaign Sequence ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def delete_sequences_sequence_id_with_http_info(sequence_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#delete_sequences_sequence_id ..."
      end
      
      # verify the required parameter 'sequence_id' is set
      fail "Missing the required parameter 'sequence_id' when calling delete_sequences_sequence_id" if sequence_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/sequences/{sequenceId}".sub('{format}','json').sub('{' + 'sequenceId' + '}', sequence_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#delete_sequences_sequence_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Query attempt limits list
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size Page size (default to 25)
    # @option opts [Integer] :page_number Page number (default to 1)
    # @option opts [String] :filter_type Filter type (default to Prefix)
    # @option opts [String] :name Name
    # @option opts [String] :sort_by Sort by
    # @option opts [String] :sort_order Sort order (default to a)
    # @return [AttemptLimitsEntityListing]
    def get_attemptlimits(opts = {})
      data, status_code, headers = get_attemptlimits_with_http_info(opts)
      return data
    end

    # Query attempt limits list
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size Page size
    # @option opts [Integer] :page_number Page number
    # @option opts [String] :filter_type Filter type
    # @option opts [String] :name Name
    # @option opts [String] :sort_by Sort by
    # @option opts [String] :sort_order Sort order
    # @return [Array<(AttemptLimitsEntityListing, Fixnum, Hash)>] AttemptLimitsEntityListing data, response status code and response headers
    def get_attemptlimits_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_attemptlimits ..."
      end
      
      if opts[:'filter_type'] && !['Equals', 'RegEx', 'Contains', 'Prefix', 'LessThan', 'LessThanEqualTo', 'GreaterThan', 'GreaterThanEqualTo', 'BeginsWith', 'EndsWith'].include?(opts[:'filter_type'])
        fail 'invalid value for "filter_type", must be one of Equals, RegEx, Contains, Prefix, LessThan, LessThanEqualTo, GreaterThan, GreaterThanEqualTo, BeginsWith, EndsWith'
      end
      
      if opts[:'sort_order'] && !['ascending', 'descending'].include?(opts[:'sort_order'])
        fail 'invalid value for "sort_order", must be one of ascending, descending'
      end
      
      # resource path
      local_var_path = "/api/v2/outbound/attemptlimits".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'pageSize'] = opts[:'page_size'] if opts[:'page_size']
      query_params[:'pageNumber'] = opts[:'page_number'] if opts[:'page_number']
      query_params[:'filterType'] = opts[:'filter_type'] if opts[:'filter_type']
      query_params[:'name'] = opts[:'name'] if opts[:'name']
      query_params[:'sortBy'] = opts[:'sort_by'] if opts[:'sort_by']
      query_params[:'sortOrder'] = opts[:'sort_order'] if opts[:'sort_order']

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AttemptLimitsEntityListing')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_attemptlimits\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get attempt limits
    # 
    # @param attempt_limits_id Attempt limits ID
    # @param [Hash] opts the optional parameters
    # @return [AttemptLimits]
    def get_attemptlimits_attemptlimits_id(attempt_limits_id, opts = {})
      data, status_code, headers = get_attemptlimits_attemptlimits_id_with_http_info(attempt_limits_id, opts)
      return data
    end

    # Get attempt limits
    # 
    # @param attempt_limits_id Attempt limits ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(AttemptLimits, Fixnum, Hash)>] AttemptLimits data, response status code and response headers
    def get_attemptlimits_attemptlimits_id_with_http_info(attempt_limits_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_attemptlimits_attemptlimits_id ..."
      end
      
      # verify the required parameter 'attempt_limits_id' is set
      fail "Missing the required parameter 'attempt_limits_id' when calling get_attemptlimits_attemptlimits_id" if attempt_limits_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/attemptlimits/{attemptLimitsId}".sub('{format}','json').sub('{' + 'attemptLimitsId' + '}', attempt_limits_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AttemptLimits')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_attemptlimits_attemptlimits_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Query callable time set list
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size Page size (default to 25)
    # @option opts [Integer] :page_number Page number (default to 1)
    # @option opts [String] :filter_type Filter type (default to Prefix)
    # @option opts [String] :name Name
    # @option opts [String] :sort_by Sort by
    # @option opts [String] :sort_order Sort order (default to a)
    # @return [CallableTimeSetEntityListing]
    def get_callabletimesets(opts = {})
      data, status_code, headers = get_callabletimesets_with_http_info(opts)
      return data
    end

    # Query callable time set list
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size Page size
    # @option opts [Integer] :page_number Page number
    # @option opts [String] :filter_type Filter type
    # @option opts [String] :name Name
    # @option opts [String] :sort_by Sort by
    # @option opts [String] :sort_order Sort order
    # @return [Array<(CallableTimeSetEntityListing, Fixnum, Hash)>] CallableTimeSetEntityListing data, response status code and response headers
    def get_callabletimesets_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_callabletimesets ..."
      end
      
      if opts[:'filter_type'] && !['Equals', 'RegEx', 'Contains', 'Prefix', 'LessThan', 'LessThanEqualTo', 'GreaterThan', 'GreaterThanEqualTo', 'BeginsWith', 'EndsWith'].include?(opts[:'filter_type'])
        fail 'invalid value for "filter_type", must be one of Equals, RegEx, Contains, Prefix, LessThan, LessThanEqualTo, GreaterThan, GreaterThanEqualTo, BeginsWith, EndsWith'
      end
      
      if opts[:'sort_order'] && !['ascending', 'descending'].include?(opts[:'sort_order'])
        fail 'invalid value for "sort_order", must be one of ascending, descending'
      end
      
      # resource path
      local_var_path = "/api/v2/outbound/callabletimesets".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'pageSize'] = opts[:'page_size'] if opts[:'page_size']
      query_params[:'pageNumber'] = opts[:'page_number'] if opts[:'page_number']
      query_params[:'filterType'] = opts[:'filter_type'] if opts[:'filter_type']
      query_params[:'name'] = opts[:'name'] if opts[:'name']
      query_params[:'sortBy'] = opts[:'sort_by'] if opts[:'sort_by']
      query_params[:'sortOrder'] = opts[:'sort_order'] if opts[:'sort_order']

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CallableTimeSetEntityListing')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_callabletimesets\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get callable time set
    # 
    # @param callable_time_set_id Callable Time Set ID
    # @param [Hash] opts the optional parameters
    # @return [CallableTimeSet]
    def get_callabletimesets_callabletimeset_id(callable_time_set_id, opts = {})
      data, status_code, headers = get_callabletimesets_callabletimeset_id_with_http_info(callable_time_set_id, opts)
      return data
    end

    # Get callable time set
    # 
    # @param callable_time_set_id Callable Time Set ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(CallableTimeSet, Fixnum, Hash)>] CallableTimeSet data, response status code and response headers
    def get_callabletimesets_callabletimeset_id_with_http_info(callable_time_set_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_callabletimesets_callabletimeset_id ..."
      end
      
      # verify the required parameter 'callable_time_set_id' is set
      fail "Missing the required parameter 'callable_time_set_id' when calling get_callabletimesets_callabletimeset_id" if callable_time_set_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/callabletimesets/{callableTimeSetId}".sub('{format}','json').sub('{' + 'callableTimeSetId' + '}', callable_time_set_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CallableTimeSet')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_callabletimesets_callabletimeset_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Query a list of dialer call analysis response sets.
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size Page size (default to 25)
    # @option opts [Integer] :page_number Page number (default to 1)
    # @option opts [String] :filter_type Filter type (default to Prefix)
    # @option opts [String] :name Name
    # @option opts [String] :sort_by Sort by
    # @option opts [String] :sort_order Sort order (default to a)
    # @return [ResponseSetEntityListing]
    def get_callanalysisresponsesets(opts = {})
      data, status_code, headers = get_callanalysisresponsesets_with_http_info(opts)
      return data
    end

    # Query a list of dialer call analysis response sets.
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size Page size
    # @option opts [Integer] :page_number Page number
    # @option opts [String] :filter_type Filter type
    # @option opts [String] :name Name
    # @option opts [String] :sort_by Sort by
    # @option opts [String] :sort_order Sort order
    # @return [Array<(ResponseSetEntityListing, Fixnum, Hash)>] ResponseSetEntityListing data, response status code and response headers
    def get_callanalysisresponsesets_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_callanalysisresponsesets ..."
      end
      
      if opts[:'filter_type'] && !['Equals', 'RegEx', 'Contains', 'Prefix', 'LessThan', 'LessThanEqualTo', 'GreaterThan', 'GreaterThanEqualTo', 'BeginsWith', 'EndsWith'].include?(opts[:'filter_type'])
        fail 'invalid value for "filter_type", must be one of Equals, RegEx, Contains, Prefix, LessThan, LessThanEqualTo, GreaterThan, GreaterThanEqualTo, BeginsWith, EndsWith'
      end
      
      if opts[:'sort_order'] && !['ascending', 'descending'].include?(opts[:'sort_order'])
        fail 'invalid value for "sort_order", must be one of ascending, descending'
      end
      
      # resource path
      local_var_path = "/api/v2/outbound/callanalysisresponsesets".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'pageSize'] = opts[:'page_size'] if opts[:'page_size']
      query_params[:'pageNumber'] = opts[:'page_number'] if opts[:'page_number']
      query_params[:'filterType'] = opts[:'filter_type'] if opts[:'filter_type']
      query_params[:'name'] = opts[:'name'] if opts[:'name']
      query_params[:'sortBy'] = opts[:'sort_by'] if opts[:'sort_by']
      query_params[:'sortOrder'] = opts[:'sort_order'] if opts[:'sort_order']

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ResponseSetEntityListing')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_callanalysisresponsesets\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get a dialer call analysis response set.
    # 
    # @param call_analysis_set_id Call Analysis Response Set ID
    # @param [Hash] opts the optional parameters
    # @return [ResponseSet]
    def get_callanalysisresponsesets_callanalysisset_id(call_analysis_set_id, opts = {})
      data, status_code, headers = get_callanalysisresponsesets_callanalysisset_id_with_http_info(call_analysis_set_id, opts)
      return data
    end

    # Get a dialer call analysis response set.
    # 
    # @param call_analysis_set_id Call Analysis Response Set ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(ResponseSet, Fixnum, Hash)>] ResponseSet data, response status code and response headers
    def get_callanalysisresponsesets_callanalysisset_id_with_http_info(call_analysis_set_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_callanalysisresponsesets_callanalysisset_id ..."
      end
      
      # verify the required parameter 'call_analysis_set_id' is set
      fail "Missing the required parameter 'call_analysis_set_id' when calling get_callanalysisresponsesets_callanalysisset_id" if call_analysis_set_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/callanalysisresponsesets/{callAnalysisSetId}".sub('{format}','json').sub('{' + 'callAnalysisSetId' + '}', call_analysis_set_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ResponseSet')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_callanalysisresponsesets_callanalysisset_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Query Campaign Rule list
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size Page size (default to 25)
    # @option opts [Integer] :page_number Page number (default to 1)
    # @option opts [String] :filter_type Filter type (default to Prefix)
    # @option opts [String] :name Name
    # @option opts [String] :sort_by Sort by
    # @option opts [String] :sort_order Sort order (default to a)
    # @return [CampaignRuleEntityListing]
    def get_campaignrules(opts = {})
      data, status_code, headers = get_campaignrules_with_http_info(opts)
      return data
    end

    # Query Campaign Rule list
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size Page size
    # @option opts [Integer] :page_number Page number
    # @option opts [String] :filter_type Filter type
    # @option opts [String] :name Name
    # @option opts [String] :sort_by Sort by
    # @option opts [String] :sort_order Sort order
    # @return [Array<(CampaignRuleEntityListing, Fixnum, Hash)>] CampaignRuleEntityListing data, response status code and response headers
    def get_campaignrules_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_campaignrules ..."
      end
      
      if opts[:'filter_type'] && !['Equals', 'RegEx', 'Contains', 'Prefix', 'LessThan', 'LessThanEqualTo', 'GreaterThan', 'GreaterThanEqualTo', 'BeginsWith', 'EndsWith'].include?(opts[:'filter_type'])
        fail 'invalid value for "filter_type", must be one of Equals, RegEx, Contains, Prefix, LessThan, LessThanEqualTo, GreaterThan, GreaterThanEqualTo, BeginsWith, EndsWith'
      end
      
      if opts[:'sort_order'] && !['ascending', 'descending'].include?(opts[:'sort_order'])
        fail 'invalid value for "sort_order", must be one of ascending, descending'
      end
      
      # resource path
      local_var_path = "/api/v2/outbound/campaignrules".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'pageSize'] = opts[:'page_size'] if opts[:'page_size']
      query_params[:'pageNumber'] = opts[:'page_number'] if opts[:'page_number']
      query_params[:'filterType'] = opts[:'filter_type'] if opts[:'filter_type']
      query_params[:'name'] = opts[:'name'] if opts[:'name']
      query_params[:'sortBy'] = opts[:'sort_by'] if opts[:'sort_by']
      query_params[:'sortOrder'] = opts[:'sort_order'] if opts[:'sort_order']

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CampaignRuleEntityListing')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_campaignrules\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Campaign Rule
    # 
    # @param campaign_rule_id Campaign Rule ID
    # @param [Hash] opts the optional parameters
    # @return [CampaignRule]
    def get_campaignrules_campaignrule_id(campaign_rule_id, opts = {})
      data, status_code, headers = get_campaignrules_campaignrule_id_with_http_info(campaign_rule_id, opts)
      return data
    end

    # Get Campaign Rule
    # 
    # @param campaign_rule_id Campaign Rule ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(CampaignRule, Fixnum, Hash)>] CampaignRule data, response status code and response headers
    def get_campaignrules_campaignrule_id_with_http_info(campaign_rule_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_campaignrules_campaignrule_id ..."
      end
      
      # verify the required parameter 'campaign_rule_id' is set
      fail "Missing the required parameter 'campaign_rule_id' when calling get_campaignrules_campaignrule_id" if campaign_rule_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/campaignrules/{campaignRuleId}".sub('{format}','json').sub('{' + 'campaignRuleId' + '}', campaign_rule_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CampaignRule')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_campaignrules_campaignrule_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Query a list of dialer campaigns.
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size Page size (default to 25)
    # @option opts [Integer] :page_number Page number (default to 1)
    # @option opts [String] :filter_type Filter type (default to Prefix)
    # @option opts [String] :name Name
    # @option opts [String] :contact_list_id Contact List ID
    # @option opts [String] :dnc_list_id DNC list ID
    # @option opts [String] :distribution_queue_id Distribution queue ID
    # @option opts [String] :edge_group_id Edge group ID
    # @option opts [String] :call_analysis_response_set_id Call analysis response set ID
    # @option opts [String] :sort_by Sort by
    # @option opts [String] :sort_order Sort order (default to a)
    # @return [CampaignEntityListing]
    def get_campaigns(opts = {})
      data, status_code, headers = get_campaigns_with_http_info(opts)
      return data
    end

    # Query a list of dialer campaigns.
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size Page size
    # @option opts [Integer] :page_number Page number
    # @option opts [String] :filter_type Filter type
    # @option opts [String] :name Name
    # @option opts [String] :contact_list_id Contact List ID
    # @option opts [String] :dnc_list_id DNC list ID
    # @option opts [String] :distribution_queue_id Distribution queue ID
    # @option opts [String] :edge_group_id Edge group ID
    # @option opts [String] :call_analysis_response_set_id Call analysis response set ID
    # @option opts [String] :sort_by Sort by
    # @option opts [String] :sort_order Sort order
    # @return [Array<(CampaignEntityListing, Fixnum, Hash)>] CampaignEntityListing data, response status code and response headers
    def get_campaigns_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_campaigns ..."
      end
      
      if opts[:'filter_type'] && !['Equals', 'RegEx', 'Contains', 'Prefix', 'LessThan', 'LessThanEqualTo', 'GreaterThan', 'GreaterThanEqualTo', 'BeginsWith', 'EndsWith'].include?(opts[:'filter_type'])
        fail 'invalid value for "filter_type", must be one of Equals, RegEx, Contains, Prefix, LessThan, LessThanEqualTo, GreaterThan, GreaterThanEqualTo, BeginsWith, EndsWith'
      end
      
      if opts[:'sort_order'] && !['ascending', 'descending'].include?(opts[:'sort_order'])
        fail 'invalid value for "sort_order", must be one of ascending, descending'
      end
      
      # resource path
      local_var_path = "/api/v2/outbound/campaigns".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'pageSize'] = opts[:'page_size'] if opts[:'page_size']
      query_params[:'pageNumber'] = opts[:'page_number'] if opts[:'page_number']
      query_params[:'filterType'] = opts[:'filter_type'] if opts[:'filter_type']
      query_params[:'name'] = opts[:'name'] if opts[:'name']
      query_params[:'contactListId'] = opts[:'contact_list_id'] if opts[:'contact_list_id']
      query_params[:'dncListId'] = opts[:'dnc_list_id'] if opts[:'dnc_list_id']
      query_params[:'distributionQueueId'] = opts[:'distribution_queue_id'] if opts[:'distribution_queue_id']
      query_params[:'edgeGroupId'] = opts[:'edge_group_id'] if opts[:'edge_group_id']
      query_params[:'callAnalysisResponseSetId'] = opts[:'call_analysis_response_set_id'] if opts[:'call_analysis_response_set_id']
      query_params[:'sortBy'] = opts[:'sort_by'] if opts[:'sort_by']
      query_params[:'sortOrder'] = opts[:'sort_order'] if opts[:'sort_order']

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CampaignEntityListing')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_campaigns\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get dialer campaign.
    # 
    # @param campaign_id Campaign ID
    # @param [Hash] opts the optional parameters
    # @return [Campaign]
    def get_campaigns_campaign_id(campaign_id, opts = {})
      data, status_code, headers = get_campaigns_campaign_id_with_http_info(campaign_id, opts)
      return data
    end

    # Get dialer campaign.
    # 
    # @param campaign_id Campaign ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(Campaign, Fixnum, Hash)>] Campaign data, response status code and response headers
    def get_campaigns_campaign_id_with_http_info(campaign_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_campaigns_campaign_id ..."
      end
      
      # verify the required parameter 'campaign_id' is set
      fail "Missing the required parameter 'campaign_id' when calling get_campaigns_campaign_id" if campaign_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/campaigns/{campaignId}".sub('{format}','json').sub('{' + 'campaignId' + '}', campaign_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Campaign')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_campaigns_campaign_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get campaign diagnostics
    # 
    # @param campaign_id Campaign ID
    # @param [Hash] opts the optional parameters
    # @return [CampaignDiagnostics]
    def get_campaigns_campaign_id_diagnostics(campaign_id, opts = {})
      data, status_code, headers = get_campaigns_campaign_id_diagnostics_with_http_info(campaign_id, opts)
      return data
    end

    # Get campaign diagnostics
    # 
    # @param campaign_id Campaign ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(CampaignDiagnostics, Fixnum, Hash)>] CampaignDiagnostics data, response status code and response headers
    def get_campaigns_campaign_id_diagnostics_with_http_info(campaign_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_campaigns_campaign_id_diagnostics ..."
      end
      
      # verify the required parameter 'campaign_id' is set
      fail "Missing the required parameter 'campaign_id' when calling get_campaigns_campaign_id_diagnostics" if campaign_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/campaigns/{campaignId}/diagnostics".sub('{format}','json').sub('{' + 'campaignId' + '}', campaign_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CampaignDiagnostics')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_campaigns_campaign_id_diagnostics\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get dialer campaign interactions.
    # 
    # @param campaign_id Campaign ID
    # @param [Hash] opts the optional parameters
    # @return [CampaignInteractions]
    def get_campaigns_campaign_id_interactions(campaign_id, opts = {})
      data, status_code, headers = get_campaigns_campaign_id_interactions_with_http_info(campaign_id, opts)
      return data
    end

    # Get dialer campaign interactions.
    # 
    # @param campaign_id Campaign ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(CampaignInteractions, Fixnum, Hash)>] CampaignInteractions data, response status code and response headers
    def get_campaigns_campaign_id_interactions_with_http_info(campaign_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_campaigns_campaign_id_interactions ..."
      end
      
      # verify the required parameter 'campaign_id' is set
      fail "Missing the required parameter 'campaign_id' when calling get_campaigns_campaign_id_interactions" if campaign_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/campaigns/{campaignId}/interactions".sub('{format}','json').sub('{' + 'campaignId' + '}', campaign_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CampaignInteractions')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_campaigns_campaign_id_interactions\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get campaign progress
    # 
    # @param campaign_id Campaign ID
    # @param [Hash] opts the optional parameters
    # @return [CampaignProgress]
    def get_campaigns_campaign_id_progress(campaign_id, opts = {})
      data, status_code, headers = get_campaigns_campaign_id_progress_with_http_info(campaign_id, opts)
      return data
    end

    # Get campaign progress
    # 
    # @param campaign_id Campaign ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(CampaignProgress, Fixnum, Hash)>] CampaignProgress data, response status code and response headers
    def get_campaigns_campaign_id_progress_with_http_info(campaign_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_campaigns_campaign_id_progress ..."
      end
      
      # verify the required parameter 'campaign_id' is set
      fail "Missing the required parameter 'campaign_id' when calling get_campaigns_campaign_id_progress" if campaign_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/campaigns/{campaignId}/progress".sub('{format}','json').sub('{' + 'campaignId' + '}', campaign_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CampaignProgress')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_campaigns_campaign_id_progress\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get statistics about a Dialer Campaign
    # 
    # @param campaign_id Campaign ID
    # @param [Hash] opts the optional parameters
    # @return [CampaignStats]
    def get_campaigns_campaign_id_stats(campaign_id, opts = {})
      data, status_code, headers = get_campaigns_campaign_id_stats_with_http_info(campaign_id, opts)
      return data
    end

    # Get statistics about a Dialer Campaign
    # 
    # @param campaign_id Campaign ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(CampaignStats, Fixnum, Hash)>] CampaignStats data, response status code and response headers
    def get_campaigns_campaign_id_stats_with_http_info(campaign_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_campaigns_campaign_id_stats ..."
      end
      
      # verify the required parameter 'campaign_id' is set
      fail "Missing the required parameter 'campaign_id' when calling get_campaigns_campaign_id_stats" if campaign_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/campaigns/{campaignId}/stats".sub('{format}','json').sub('{' + 'campaignId' + '}', campaign_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CampaignStats')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_campaigns_campaign_id_stats\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Query a list of contact lists.
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :include_import_status Include import status (default to false)
    # @option opts [BOOLEAN] :include_size Include size (default to false)
    # @option opts [Integer] :page_size Page size (default to 25)
    # @option opts [Integer] :page_number Page number (default to 1)
    # @option opts [String] :filter_type Filter type (default to Prefix)
    # @option opts [String] :name Name
    # @option opts [String] :sort_by Sort by
    # @option opts [String] :sort_order Sort order (default to a)
    # @return [ContactListEntityListing]
    def get_contactlists(opts = {})
      data, status_code, headers = get_contactlists_with_http_info(opts)
      return data
    end

    # Query a list of contact lists.
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :include_import_status Include import status
    # @option opts [BOOLEAN] :include_size Include size
    # @option opts [Integer] :page_size Page size
    # @option opts [Integer] :page_number Page number
    # @option opts [String] :filter_type Filter type
    # @option opts [String] :name Name
    # @option opts [String] :sort_by Sort by
    # @option opts [String] :sort_order Sort order
    # @return [Array<(ContactListEntityListing, Fixnum, Hash)>] ContactListEntityListing data, response status code and response headers
    def get_contactlists_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_contactlists ..."
      end
      
      if opts[:'filter_type'] && !['Equals', 'RegEx', 'Contains', 'Prefix', 'LessThan', 'LessThanEqualTo', 'GreaterThan', 'GreaterThanEqualTo', 'BeginsWith', 'EndsWith'].include?(opts[:'filter_type'])
        fail 'invalid value for "filter_type", must be one of Equals, RegEx, Contains, Prefix, LessThan, LessThanEqualTo, GreaterThan, GreaterThanEqualTo, BeginsWith, EndsWith'
      end
      
      if opts[:'sort_order'] && !['ascending', 'descending'].include?(opts[:'sort_order'])
        fail 'invalid value for "sort_order", must be one of ascending, descending'
      end
      
      # resource path
      local_var_path = "/api/v2/outbound/contactlists".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'includeImportStatus'] = opts[:'include_import_status'] if opts[:'include_import_status']
      query_params[:'includeSize'] = opts[:'include_size'] if opts[:'include_size']
      query_params[:'pageSize'] = opts[:'page_size'] if opts[:'page_size']
      query_params[:'pageNumber'] = opts[:'page_number'] if opts[:'page_number']
      query_params[:'filterType'] = opts[:'filter_type'] if opts[:'filter_type']
      query_params[:'name'] = opts[:'name'] if opts[:'name']
      query_params[:'sortBy'] = opts[:'sort_by'] if opts[:'sort_by']
      query_params[:'sortOrder'] = opts[:'sort_order'] if opts[:'sort_order']

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ContactListEntityListing')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_contactlists\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get a dialer contact list.
    # 
    # @param contact_list_id ContactList ID
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :include_import_status Import status (default to false)
    # @option opts [BOOLEAN] :include_size Include size (default to false)
    # @return [ContactList]
    def get_contactlists_contactlist_id(contact_list_id, opts = {})
      data, status_code, headers = get_contactlists_contactlist_id_with_http_info(contact_list_id, opts)
      return data
    end

    # Get a dialer contact list.
    # 
    # @param contact_list_id ContactList ID
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :include_import_status Import status
    # @option opts [BOOLEAN] :include_size Include size
    # @return [Array<(ContactList, Fixnum, Hash)>] ContactList data, response status code and response headers
    def get_contactlists_contactlist_id_with_http_info(contact_list_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_contactlists_contactlist_id ..."
      end
      
      # verify the required parameter 'contact_list_id' is set
      fail "Missing the required parameter 'contact_list_id' when calling get_contactlists_contactlist_id" if contact_list_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/contactlists/{contactListId}".sub('{format}','json').sub('{' + 'contactListId' + '}', contact_list_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'includeImportStatus'] = opts[:'include_import_status'] if opts[:'include_import_status']
      query_params[:'includeSize'] = opts[:'include_size'] if opts[:'include_size']

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ContactList')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_contactlists_contactlist_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get a contact.
    # 
    # @param contact_list_id Contact List ID
    # @param contact_id Contact ID
    # @param [Hash] opts the optional parameters
    # @return [DialerContact]
    def get_contactlists_contactlist_id_contacts_contact_id(contact_list_id, contact_id, opts = {})
      data, status_code, headers = get_contactlists_contactlist_id_contacts_contact_id_with_http_info(contact_list_id, contact_id, opts)
      return data
    end

    # Get a contact.
    # 
    # @param contact_list_id Contact List ID
    # @param contact_id Contact ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(DialerContact, Fixnum, Hash)>] DialerContact data, response status code and response headers
    def get_contactlists_contactlist_id_contacts_contact_id_with_http_info(contact_list_id, contact_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_contactlists_contactlist_id_contacts_contact_id ..."
      end
      
      # verify the required parameter 'contact_list_id' is set
      fail "Missing the required parameter 'contact_list_id' when calling get_contactlists_contactlist_id_contacts_contact_id" if contact_list_id.nil?
      
      # verify the required parameter 'contact_id' is set
      fail "Missing the required parameter 'contact_id' when calling get_contactlists_contactlist_id_contacts_contact_id" if contact_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/contactlists/{contactListId}/contacts/{contactId}".sub('{format}','json').sub('{' + 'contactListId' + '}', contact_list_id.to_s).sub('{' + 'contactId' + '}', contact_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'DialerContact')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_contactlists_contactlist_id_contacts_contact_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get the URI of a contact list export.
    # 
    # @param contact_list_id ContactList ID
    # @param [Hash] opts the optional parameters
    # @option opts [String] :download Redirect to download uri (default to false)
    # @return [ExportUri]
    def get_contactlists_contactlist_id_export(contact_list_id, opts = {})
      data, status_code, headers = get_contactlists_contactlist_id_export_with_http_info(contact_list_id, opts)
      return data
    end

    # Get the URI of a contact list export.
    # 
    # @param contact_list_id ContactList ID
    # @param [Hash] opts the optional parameters
    # @option opts [String] :download Redirect to download uri
    # @return [Array<(ExportUri, Fixnum, Hash)>] ExportUri data, response status code and response headers
    def get_contactlists_contactlist_id_export_with_http_info(contact_list_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_contactlists_contactlist_id_export ..."
      end
      
      # verify the required parameter 'contact_list_id' is set
      fail "Missing the required parameter 'contact_list_id' when calling get_contactlists_contactlist_id_export" if contact_list_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/contactlists/{contactListId}/export".sub('{format}','json').sub('{' + 'contactListId' + '}', contact_list_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'download'] = opts[:'download'] if opts[:'download']

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ExportUri')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_contactlists_contactlist_id_export\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get dialer contactList import status.
    # 
    # @param contact_list_id ContactList ID
    # @param [Hash] opts the optional parameters
    # @return [ImportStatus]
    def get_contactlists_contactlist_id_importstatus(contact_list_id, opts = {})
      data, status_code, headers = get_contactlists_contactlist_id_importstatus_with_http_info(contact_list_id, opts)
      return data
    end

    # Get dialer contactList import status.
    # 
    # @param contact_list_id ContactList ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(ImportStatus, Fixnum, Hash)>] ImportStatus data, response status code and response headers
    def get_contactlists_contactlist_id_importstatus_with_http_info(contact_list_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_contactlists_contactlist_id_importstatus ..."
      end
      
      # verify the required parameter 'contact_list_id' is set
      fail "Missing the required parameter 'contact_list_id' when calling get_contactlists_contactlist_id_importstatus" if contact_list_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/contactlists/{contactListId}/importstatus".sub('{format}','json').sub('{' + 'contactListId' + '}', contact_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ImportStatus')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_contactlists_contactlist_id_importstatus\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Query dialer DNC lists
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :include_import_status Import status (default to false)
    # @option opts [BOOLEAN] :include_size Include size (default to false)
    # @option opts [Integer] :page_size Page size (default to 25)
    # @option opts [Integer] :page_number Page number (default to 1)
    # @option opts [String] :filter_type Filter type (default to Prefix)
    # @option opts [String] :name Name
    # @option opts [String] :sort_by Sort by
    # @option opts [String] :sort_order Sort order
    # @return [DncListEntityListing]
    def get_dnclists(opts = {})
      data, status_code, headers = get_dnclists_with_http_info(opts)
      return data
    end

    # Query dialer DNC lists
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :include_import_status Import status
    # @option opts [BOOLEAN] :include_size Include size
    # @option opts [Integer] :page_size Page size
    # @option opts [Integer] :page_number Page number
    # @option opts [String] :filter_type Filter type
    # @option opts [String] :name Name
    # @option opts [String] :sort_by Sort by
    # @option opts [String] :sort_order Sort order
    # @return [Array<(DncListEntityListing, Fixnum, Hash)>] DncListEntityListing data, response status code and response headers
    def get_dnclists_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_dnclists ..."
      end
      
      if opts[:'filter_type'] && !['Equals', 'RegEx', 'Contains', 'Prefix', 'LessThan', 'LessThanEqualTo', 'GreaterThan', 'GreaterThanEqualTo', 'BeginsWith', 'EndsWith'].include?(opts[:'filter_type'])
        fail 'invalid value for "filter_type", must be one of Equals, RegEx, Contains, Prefix, LessThan, LessThanEqualTo, GreaterThan, GreaterThanEqualTo, BeginsWith, EndsWith'
      end
      
      if opts[:'sort_order'] && !['ascending', 'descending'].include?(opts[:'sort_order'])
        fail 'invalid value for "sort_order", must be one of ascending, descending'
      end
      
      # resource path
      local_var_path = "/api/v2/outbound/dnclists".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'includeImportStatus'] = opts[:'include_import_status'] if opts[:'include_import_status']
      query_params[:'includeSize'] = opts[:'include_size'] if opts[:'include_size']
      query_params[:'pageSize'] = opts[:'page_size'] if opts[:'page_size']
      query_params[:'pageNumber'] = opts[:'page_number'] if opts[:'page_number']
      query_params[:'filterType'] = opts[:'filter_type'] if opts[:'filter_type']
      query_params[:'name'] = opts[:'name'] if opts[:'name']
      query_params[:'sortBy'] = opts[:'sort_by'] if opts[:'sort_by']
      query_params[:'sortOrder'] = opts[:'sort_order'] if opts[:'sort_order']

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'DncListEntityListing')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_dnclists\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get dialer DNC list
    # 
    # @param dnc_list_id DncList ID
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :include_import_status Import status (default to false)
    # @option opts [BOOLEAN] :include_size Include size (default to false)
    # @return [DncList]
    def get_dnclists_dnclist_id(dnc_list_id, opts = {})
      data, status_code, headers = get_dnclists_dnclist_id_with_http_info(dnc_list_id, opts)
      return data
    end

    # Get dialer DNC list
    # 
    # @param dnc_list_id DncList ID
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :include_import_status Import status
    # @option opts [BOOLEAN] :include_size Include size
    # @return [Array<(DncList, Fixnum, Hash)>] DncList data, response status code and response headers
    def get_dnclists_dnclist_id_with_http_info(dnc_list_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_dnclists_dnclist_id ..."
      end
      
      # verify the required parameter 'dnc_list_id' is set
      fail "Missing the required parameter 'dnc_list_id' when calling get_dnclists_dnclist_id" if dnc_list_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/dnclists/{dncListId}".sub('{format}','json').sub('{' + 'dncListId' + '}', dnc_list_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'includeImportStatus'] = opts[:'include_import_status'] if opts[:'include_import_status']
      query_params[:'includeSize'] = opts[:'include_size'] if opts[:'include_size']

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'DncList')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_dnclists_dnclist_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get the URI of a DNC list export.
    # 
    # @param dnc_list_id DncList ID
    # @param [Hash] opts the optional parameters
    # @option opts [String] :download Redirect to download uri (default to false)
    # @return [ExportUri]
    def get_dnclists_dnclist_id_export(dnc_list_id, opts = {})
      data, status_code, headers = get_dnclists_dnclist_id_export_with_http_info(dnc_list_id, opts)
      return data
    end

    # Get the URI of a DNC list export.
    # 
    # @param dnc_list_id DncList ID
    # @param [Hash] opts the optional parameters
    # @option opts [String] :download Redirect to download uri
    # @return [Array<(ExportUri, Fixnum, Hash)>] ExportUri data, response status code and response headers
    def get_dnclists_dnclist_id_export_with_http_info(dnc_list_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_dnclists_dnclist_id_export ..."
      end
      
      # verify the required parameter 'dnc_list_id' is set
      fail "Missing the required parameter 'dnc_list_id' when calling get_dnclists_dnclist_id_export" if dnc_list_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/dnclists/{dncListId}/export".sub('{format}','json').sub('{' + 'dncListId' + '}', dnc_list_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'download'] = opts[:'download'] if opts[:'download']

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ExportUri')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_dnclists_dnclist_id_export\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get dialer dncList import status.
    # 
    # @param dnc_list_id DncList ID
    # @param [Hash] opts the optional parameters
    # @return [ImportStatus]
    def get_dnclists_dnclist_id_importstatus(dnc_list_id, opts = {})
      data, status_code, headers = get_dnclists_dnclist_id_importstatus_with_http_info(dnc_list_id, opts)
      return data
    end

    # Get dialer dncList import status.
    # 
    # @param dnc_list_id DncList ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(ImportStatus, Fixnum, Hash)>] ImportStatus data, response status code and response headers
    def get_dnclists_dnclist_id_importstatus_with_http_info(dnc_list_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_dnclists_dnclist_id_importstatus ..."
      end
      
      # verify the required parameter 'dnc_list_id' is set
      fail "Missing the required parameter 'dnc_list_id' when calling get_dnclists_dnclist_id_importstatus" if dnc_list_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/dnclists/{dncListId}/importstatus".sub('{format}','json').sub('{' + 'dncListId' + '}', dnc_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ImportStatus')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_dnclists_dnclist_id_importstatus\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Query Event Logs
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size Page size (default to 25)
    # @option opts [Integer] :page_number Page number (default to 1)
    # @option opts [String] :filter_type Filter type (default to Prefix)
    # @option opts [String] :sort_by Sort by
    # @option opts [String] :sort_order Sort order (default to a)
    # @return [DialerEventEntityListing]
    def get_events(opts = {})
      data, status_code, headers = get_events_with_http_info(opts)
      return data
    end

    # Query Event Logs
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size Page size
    # @option opts [Integer] :page_number Page number
    # @option opts [String] :filter_type Filter type
    # @option opts [String] :sort_by Sort by
    # @option opts [String] :sort_order Sort order
    # @return [Array<(DialerEventEntityListing, Fixnum, Hash)>] DialerEventEntityListing data, response status code and response headers
    def get_events_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_events ..."
      end
      
      if opts[:'filter_type'] && !['Equals', 'RegEx', 'Contains', 'Prefix', 'LessThan', 'LessThanEqualTo', 'GreaterThan', 'GreaterThanEqualTo', 'BeginsWith', 'EndsWith'].include?(opts[:'filter_type'])
        fail 'invalid value for "filter_type", must be one of Equals, RegEx, Contains, Prefix, LessThan, LessThanEqualTo, GreaterThan, GreaterThanEqualTo, BeginsWith, EndsWith'
      end
      
      if opts[:'sort_order'] && !['ascending', 'descending'].include?(opts[:'sort_order'])
        fail 'invalid value for "sort_order", must be one of ascending, descending'
      end
      
      # resource path
      local_var_path = "/api/v2/outbound/events".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'pageSize'] = opts[:'page_size'] if opts[:'page_size']
      query_params[:'pageNumber'] = opts[:'page_number'] if opts[:'page_number']
      query_params[:'filterType'] = opts[:'filter_type'] if opts[:'filter_type']
      query_params[:'sortBy'] = opts[:'sort_by'] if opts[:'sort_by']
      query_params[:'sortOrder'] = opts[:'sort_order'] if opts[:'sort_order']

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'DialerEventEntityListing')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_events\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Dialer Event
    # 
    # @param event_id Event Log ID
    # @param [Hash] opts the optional parameters
    # @return [EventLog]
    def get_events_event_id(event_id, opts = {})
      data, status_code, headers = get_events_event_id_with_http_info(event_id, opts)
      return data
    end

    # Get Dialer Event
    # 
    # @param event_id Event Log ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(EventLog, Fixnum, Hash)>] EventLog data, response status code and response headers
    def get_events_event_id_with_http_info(event_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_events_event_id ..."
      end
      
      # verify the required parameter 'event_id' is set
      fail "Missing the required parameter 'event_id' when calling get_events_event_id" if event_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/events/{eventId}".sub('{format}','json').sub('{' + 'eventId' + '}', event_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'EventLog')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_events_event_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Query a list of Rule Sets.
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size Page size (default to 25)
    # @option opts [Integer] :page_number Page number (default to 1)
    # @option opts [String] :filter_type Filter type (default to Prefix)
    # @option opts [String] :name Name
    # @option opts [String] :sort_by Sort by
    # @option opts [String] :sort_order Sort order (default to a)
    # @return [RuleSetEntityListing]
    def get_rulesets(opts = {})
      data, status_code, headers = get_rulesets_with_http_info(opts)
      return data
    end

    # Query a list of Rule Sets.
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size Page size
    # @option opts [Integer] :page_number Page number
    # @option opts [String] :filter_type Filter type
    # @option opts [String] :name Name
    # @option opts [String] :sort_by Sort by
    # @option opts [String] :sort_order Sort order
    # @return [Array<(RuleSetEntityListing, Fixnum, Hash)>] RuleSetEntityListing data, response status code and response headers
    def get_rulesets_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_rulesets ..."
      end
      
      if opts[:'filter_type'] && !['Equals', 'RegEx', 'Contains', 'Prefix', 'LessThan', 'LessThanEqualTo', 'GreaterThan', 'GreaterThanEqualTo', 'BeginsWith', 'EndsWith'].include?(opts[:'filter_type'])
        fail 'invalid value for "filter_type", must be one of Equals, RegEx, Contains, Prefix, LessThan, LessThanEqualTo, GreaterThan, GreaterThanEqualTo, BeginsWith, EndsWith'
      end
      
      if opts[:'sort_order'] && !['ascending', 'descending'].include?(opts[:'sort_order'])
        fail 'invalid value for "sort_order", must be one of ascending, descending'
      end
      
      # resource path
      local_var_path = "/api/v2/outbound/rulesets".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'pageSize'] = opts[:'page_size'] if opts[:'page_size']
      query_params[:'pageNumber'] = opts[:'page_number'] if opts[:'page_number']
      query_params[:'filterType'] = opts[:'filter_type'] if opts[:'filter_type']
      query_params[:'name'] = opts[:'name'] if opts[:'name']
      query_params[:'sortBy'] = opts[:'sort_by'] if opts[:'sort_by']
      query_params[:'sortOrder'] = opts[:'sort_order'] if opts[:'sort_order']

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'RuleSetEntityListing')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_rulesets\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get a Rule Set by ID.
    # 
    # @param rule_set_id Rule Set ID
    # @param [Hash] opts the optional parameters
    # @return [RuleSet]
    def get_rulesets_ruleset_id(rule_set_id, opts = {})
      data, status_code, headers = get_rulesets_ruleset_id_with_http_info(rule_set_id, opts)
      return data
    end

    # Get a Rule Set by ID.
    # 
    # @param rule_set_id Rule Set ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(RuleSet, Fixnum, Hash)>] RuleSet data, response status code and response headers
    def get_rulesets_ruleset_id_with_http_info(rule_set_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_rulesets_ruleset_id ..."
      end
      
      # verify the required parameter 'rule_set_id' is set
      fail "Missing the required parameter 'rule_set_id' when calling get_rulesets_ruleset_id" if rule_set_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/rulesets/{ruleSetId}".sub('{format}','json').sub('{' + 'ruleSetId' + '}', rule_set_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'RuleSet')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_rulesets_ruleset_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Query for a list of dialer campaign schedules.
    # 
    # @param [Hash] opts the optional parameters
    # @return [Array<CampaignSchedule>]
    def get_schedules_campaigns(opts = {})
      data, status_code, headers = get_schedules_campaigns_with_http_info(opts)
      return data
    end

    # Query for a list of dialer campaign schedules.
    # 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<CampaignSchedule>, Fixnum, Hash)>] Array<CampaignSchedule> data, response status code and response headers
    def get_schedules_campaigns_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_schedules_campaigns ..."
      end
      
      # resource path
      local_var_path = "/api/v2/outbound/schedules/campaigns".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<CampaignSchedule>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_schedules_campaigns\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get a dialer campaign schedule.
    # 
    # @param campaign_id Campaign ID
    # @param [Hash] opts the optional parameters
    # @return [CampaignSchedule]
    def get_schedules_campaigns_campaign_id(campaign_id, opts = {})
      data, status_code, headers = get_schedules_campaigns_campaign_id_with_http_info(campaign_id, opts)
      return data
    end

    # Get a dialer campaign schedule.
    # 
    # @param campaign_id Campaign ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(CampaignSchedule, Fixnum, Hash)>] CampaignSchedule data, response status code and response headers
    def get_schedules_campaigns_campaign_id_with_http_info(campaign_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_schedules_campaigns_campaign_id ..."
      end
      
      # verify the required parameter 'campaign_id' is set
      fail "Missing the required parameter 'campaign_id' when calling get_schedules_campaigns_campaign_id" if campaign_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/schedules/campaigns/{campaignId}".sub('{format}','json').sub('{' + 'campaignId' + '}', campaign_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CampaignSchedule')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_schedules_campaigns_campaign_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Query for a list of dialer sequence schedules.
    # 
    # @param [Hash] opts the optional parameters
    # @return [Array<SequenceSchedule>]
    def get_schedules_sequences(opts = {})
      data, status_code, headers = get_schedules_sequences_with_http_info(opts)
      return data
    end

    # Query for a list of dialer sequence schedules.
    # 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<SequenceSchedule>, Fixnum, Hash)>] Array<SequenceSchedule> data, response status code and response headers
    def get_schedules_sequences_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_schedules_sequences ..."
      end
      
      # resource path
      local_var_path = "/api/v2/outbound/schedules/sequences".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<SequenceSchedule>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_schedules_sequences\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get a dialer sequence schedule.
    # 
    # @param sequence_id Sequence ID
    # @param [Hash] opts the optional parameters
    # @return [SequenceSchedule]
    def get_schedules_sequences_sequence_id(sequence_id, opts = {})
      data, status_code, headers = get_schedules_sequences_sequence_id_with_http_info(sequence_id, opts)
      return data
    end

    # Get a dialer sequence schedule.
    # 
    # @param sequence_id Sequence ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(SequenceSchedule, Fixnum, Hash)>] SequenceSchedule data, response status code and response headers
    def get_schedules_sequences_sequence_id_with_http_info(sequence_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_schedules_sequences_sequence_id ..."
      end
      
      # verify the required parameter 'sequence_id' is set
      fail "Missing the required parameter 'sequence_id' when calling get_schedules_sequences_sequence_id" if sequence_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/schedules/sequences/{sequenceId}".sub('{format}','json').sub('{' + 'sequenceId' + '}', sequence_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'SequenceSchedule')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_schedules_sequences_sequence_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Query a list of dialer campaign sequences.
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size Page size (default to 25)
    # @option opts [Integer] :page_number Page number (default to 1)
    # @option opts [String] :filter_type Filter type (default to Prefix)
    # @option opts [String] :name Name
    # @option opts [String] :sort_by Sort by
    # @option opts [String] :sort_order Sort order (default to a)
    # @return [CampaignSequenceEntityListing]
    def get_sequences(opts = {})
      data, status_code, headers = get_sequences_with_http_info(opts)
      return data
    end

    # Query a list of dialer campaign sequences.
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size Page size
    # @option opts [Integer] :page_number Page number
    # @option opts [String] :filter_type Filter type
    # @option opts [String] :name Name
    # @option opts [String] :sort_by Sort by
    # @option opts [String] :sort_order Sort order
    # @return [Array<(CampaignSequenceEntityListing, Fixnum, Hash)>] CampaignSequenceEntityListing data, response status code and response headers
    def get_sequences_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_sequences ..."
      end
      
      if opts[:'filter_type'] && !['Equals', 'RegEx', 'Contains', 'Prefix', 'LessThan', 'LessThanEqualTo', 'GreaterThan', 'GreaterThanEqualTo', 'BeginsWith', 'EndsWith'].include?(opts[:'filter_type'])
        fail 'invalid value for "filter_type", must be one of Equals, RegEx, Contains, Prefix, LessThan, LessThanEqualTo, GreaterThan, GreaterThanEqualTo, BeginsWith, EndsWith'
      end
      
      if opts[:'sort_order'] && !['ascending', 'descending'].include?(opts[:'sort_order'])
        fail 'invalid value for "sort_order", must be one of ascending, descending'
      end
      
      # resource path
      local_var_path = "/api/v2/outbound/sequences".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'pageSize'] = opts[:'page_size'] if opts[:'page_size']
      query_params[:'pageNumber'] = opts[:'page_number'] if opts[:'page_number']
      query_params[:'filterType'] = opts[:'filter_type'] if opts[:'filter_type']
      query_params[:'name'] = opts[:'name'] if opts[:'name']
      query_params[:'sortBy'] = opts[:'sort_by'] if opts[:'sort_by']
      query_params[:'sortOrder'] = opts[:'sort_order'] if opts[:'sort_order']

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CampaignSequenceEntityListing')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_sequences\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get a dialer campaign sequence.
    # 
    # @param sequence_id Campaign Sequence ID
    # @param [Hash] opts the optional parameters
    # @return [CampaignSequence]
    def get_sequences_sequence_id(sequence_id, opts = {})
      data, status_code, headers = get_sequences_sequence_id_with_http_info(sequence_id, opts)
      return data
    end

    # Get a dialer campaign sequence.
    # 
    # @param sequence_id Campaign Sequence ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(CampaignSequence, Fixnum, Hash)>] CampaignSequence data, response status code and response headers
    def get_sequences_sequence_id_with_http_info(sequence_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_sequences_sequence_id ..."
      end
      
      # verify the required parameter 'sequence_id' is set
      fail "Missing the required parameter 'sequence_id' when calling get_sequences_sequence_id" if sequence_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/sequences/{sequenceId}".sub('{format}','json').sub('{' + 'sequenceId' + '}', sequence_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CampaignSequence')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_sequences_sequence_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get the Dialer wrap up code mapping.
    # 
    # @param [Hash] opts the optional parameters
    # @return [WrapUpCodeMapping]
    def get_wrapupcodemappings(opts = {})
      data, status_code, headers = get_wrapupcodemappings_with_http_info(opts)
      return data
    end

    # Get the Dialer wrap up code mapping.
    # 
    # @param [Hash] opts the optional parameters
    # @return [Array<(WrapUpCodeMapping, Fixnum, Hash)>] WrapUpCodeMapping data, response status code and response headers
    def get_wrapupcodemappings_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#get_wrapupcodemappings ..."
      end
      
      # resource path
      local_var_path = "/api/v2/outbound/wrapupcodemappings".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'WrapUpCodeMapping')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#get_wrapupcodemappings\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create attempt limits
    # 
    # @param body AttemptLimits
    # @param [Hash] opts the optional parameters
    # @return [AttemptLimits]
    def post_attemptlimits(body, opts = {})
      data, status_code, headers = post_attemptlimits_with_http_info(body, opts)
      return data
    end

    # Create attempt limits
    # 
    # @param body AttemptLimits
    # @param [Hash] opts the optional parameters
    # @return [Array<(AttemptLimits, Fixnum, Hash)>] AttemptLimits data, response status code and response headers
    def post_attemptlimits_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#post_attemptlimits ..."
      end
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling post_attemptlimits" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/attemptlimits".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AttemptLimits')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#post_attemptlimits\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Retrieves audits for dialer.
    # 
    # @param body AuditSearch
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size Page size (default to 25)
    # @option opts [Integer] :page_number Page number (default to 1)
    # @option opts [String] :sort_by Sort by (default to entity.name)
    # @option opts [String] :sort_order Sort order (default to ascending)
    # @option opts [BOOLEAN] :facets_only Facets only (default to false)
    # @return [AuditSearchResult]
    def post_audits(body, opts = {})
      data, status_code, headers = post_audits_with_http_info(body, opts)
      return data
    end

    # Retrieves audits for dialer.
    # 
    # @param body AuditSearch
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size Page size
    # @option opts [Integer] :page_number Page number
    # @option opts [String] :sort_by Sort by
    # @option opts [String] :sort_order Sort order
    # @option opts [BOOLEAN] :facets_only Facets only
    # @return [Array<(AuditSearchResult, Fixnum, Hash)>] AuditSearchResult data, response status code and response headers
    def post_audits_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#post_audits ..."
      end
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling post_audits" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/audits".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'pageSize'] = opts[:'page_size'] if opts[:'page_size']
      query_params[:'pageNumber'] = opts[:'page_number'] if opts[:'page_number']
      query_params[:'sortBy'] = opts[:'sort_by'] if opts[:'sort_by']
      query_params[:'sortOrder'] = opts[:'sort_order'] if opts[:'sort_order']
      query_params[:'facetsOnly'] = opts[:'facets_only'] if opts[:'facets_only']

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AuditSearchResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#post_audits\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create callable time set
    # 
    # @param body DialerCallableTimeSet
    # @param [Hash] opts the optional parameters
    # @return [CallableTimeSet]
    def post_callabletimesets(body, opts = {})
      data, status_code, headers = post_callabletimesets_with_http_info(body, opts)
      return data
    end

    # Create callable time set
    # 
    # @param body DialerCallableTimeSet
    # @param [Hash] opts the optional parameters
    # @return [Array<(CallableTimeSet, Fixnum, Hash)>] CallableTimeSet data, response status code and response headers
    def post_callabletimesets_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#post_callabletimesets ..."
      end
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling post_callabletimesets" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/callabletimesets".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CallableTimeSet')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#post_callabletimesets\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create a dialer call analysis response set.
    # 
    # @param body ResponseSet
    # @param [Hash] opts the optional parameters
    # @return [ResponseSet]
    def post_callanalysisresponsesets(body, opts = {})
      data, status_code, headers = post_callanalysisresponsesets_with_http_info(body, opts)
      return data
    end

    # Create a dialer call analysis response set.
    # 
    # @param body ResponseSet
    # @param [Hash] opts the optional parameters
    # @return [Array<(ResponseSet, Fixnum, Hash)>] ResponseSet data, response status code and response headers
    def post_callanalysisresponsesets_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#post_callanalysisresponsesets ..."
      end
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling post_callanalysisresponsesets" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/callanalysisresponsesets".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ResponseSet')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#post_callanalysisresponsesets\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create Campaign Rule
    # 
    # @param body CampaignRule
    # @param [Hash] opts the optional parameters
    # @return [CampaignRule]
    def post_campaignrules(body, opts = {})
      data, status_code, headers = post_campaignrules_with_http_info(body, opts)
      return data
    end

    # Create Campaign Rule
    # 
    # @param body CampaignRule
    # @param [Hash] opts the optional parameters
    # @return [Array<(CampaignRule, Fixnum, Hash)>] CampaignRule data, response status code and response headers
    def post_campaignrules_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#post_campaignrules ..."
      end
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling post_campaignrules" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/campaignrules".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CampaignRule')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#post_campaignrules\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create a campaign.
    # 
    # @param body Campaign
    # @param [Hash] opts the optional parameters
    # @return [Campaign]
    def post_campaigns(body, opts = {})
      data, status_code, headers = post_campaigns_with_http_info(body, opts)
      return data
    end

    # Create a campaign.
    # 
    # @param body Campaign
    # @param [Hash] opts the optional parameters
    # @return [Array<(Campaign, Fixnum, Hash)>] Campaign data, response status code and response headers
    def post_campaigns_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#post_campaigns ..."
      end
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling post_campaigns" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/campaigns".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Campaign')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#post_campaigns\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Schedule a Callback for a Dialer Campaign (Deprecated)
    # This endpoint is deprecated and may have unexpected results. Please use \"/conversations/{conversationId}/participants/{participantId}/callbacks instead.\"
    # @param campaign_id Campaign ID
    # @param body ContactCallbackRequest
    # @param [Hash] opts the optional parameters
    # @return [ContactCallbackRequest]
    def post_campaigns_campaign_id_callback_schedule(campaign_id, body, opts = {})
      data, status_code, headers = post_campaigns_campaign_id_callback_schedule_with_http_info(campaign_id, body, opts)
      return data
    end

    # Schedule a Callback for a Dialer Campaign (Deprecated)
    # This endpoint is deprecated and may have unexpected results. Please use \&quot;/conversations/{conversationId}/participants/{participantId}/callbacks instead.\&quot;
    # @param campaign_id Campaign ID
    # @param body ContactCallbackRequest
    # @param [Hash] opts the optional parameters
    # @return [Array<(ContactCallbackRequest, Fixnum, Hash)>] ContactCallbackRequest data, response status code and response headers
    def post_campaigns_campaign_id_callback_schedule_with_http_info(campaign_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#post_campaigns_campaign_id_callback_schedule ..."
      end
      
      # verify the required parameter 'campaign_id' is set
      fail "Missing the required parameter 'campaign_id' when calling post_campaigns_campaign_id_callback_schedule" if campaign_id.nil?
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling post_campaigns_campaign_id_callback_schedule" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/campaigns/{campaignId}/callback/schedule".sub('{format}','json').sub('{' + 'campaignId' + '}', campaign_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ContactCallbackRequest')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#post_campaigns_campaign_id_callback_schedule\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get progress for a list of campaigns
    # 
    # @param body Campaign IDs
    # @param [Hash] opts the optional parameters
    # @return [Array<CampaignProgress>]
    def post_campaigns_progress(body, opts = {})
      data, status_code, headers = post_campaigns_progress_with_http_info(body, opts)
      return data
    end

    # Get progress for a list of campaigns
    # 
    # @param body Campaign IDs
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<CampaignProgress>, Fixnum, Hash)>] Array<CampaignProgress> data, response status code and response headers
    def post_campaigns_progress_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#post_campaigns_progress ..."
      end
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling post_campaigns_progress" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/campaigns/progress".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<CampaignProgress>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#post_campaigns_progress\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create a contact List.
    # 
    # @param body ContactList
    # @param [Hash] opts the optional parameters
    # @return [ContactList]
    def post_contactlists(body, opts = {})
      data, status_code, headers = post_contactlists_with_http_info(body, opts)
      return data
    end

    # Create a contact List.
    # 
    # @param body ContactList
    # @param [Hash] opts the optional parameters
    # @return [Array<(ContactList, Fixnum, Hash)>] ContactList data, response status code and response headers
    def post_contactlists_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#post_contactlists ..."
      end
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling post_contactlists" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/contactlists".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ContactList')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#post_contactlists\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Add contacts to a contact list.
    # 
    # @param contact_list_id Contact List ID
    # @param body Contact
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :priority Contact priority.  True means the contact(s) will go to the beginning of the list, false means at the end.
    # @option opts [BOOLEAN] :clear_system_data Clear system data.  True means the system data stored on the contact will be cleared if the contact already exists (attempts, callable status, etc), false means it won&#39;t.
    # @return [Array<DialerContact>]
    def post_contactlists_contactlist_id_contacts(contact_list_id, body, opts = {})
      data, status_code, headers = post_contactlists_contactlist_id_contacts_with_http_info(contact_list_id, body, opts)
      return data
    end

    # Add contacts to a contact list.
    # 
    # @param contact_list_id Contact List ID
    # @param body Contact
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :priority Contact priority.  True means the contact(s) will go to the beginning of the list, false means at the end.
    # @option opts [BOOLEAN] :clear_system_data Clear system data.  True means the system data stored on the contact will be cleared if the contact already exists (attempts, callable status, etc), false means it won&#39;t.
    # @return [Array<(Array<DialerContact>, Fixnum, Hash)>] Array<DialerContact> data, response status code and response headers
    def post_contactlists_contactlist_id_contacts_with_http_info(contact_list_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#post_contactlists_contactlist_id_contacts ..."
      end
      
      # verify the required parameter 'contact_list_id' is set
      fail "Missing the required parameter 'contact_list_id' when calling post_contactlists_contactlist_id_contacts" if contact_list_id.nil?
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling post_contactlists_contactlist_id_contacts" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/contactlists/{contactListId}/contacts".sub('{format}','json').sub('{' + 'contactListId' + '}', contact_list_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'priority'] = opts[:'priority'] if opts[:'priority']
      query_params[:'clearSystemData'] = opts[:'clear_system_data'] if opts[:'clear_system_data']

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<DialerContact>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#post_contactlists_contactlist_id_contacts\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Initiate the export of a contact list.
    # Returns 200 if received OK.
    # @param contact_list_id ContactList ID
    # @param [Hash] opts the optional parameters
    # @return [UriReference]
    def post_contactlists_contactlist_id_export(contact_list_id, opts = {})
      data, status_code, headers = post_contactlists_contactlist_id_export_with_http_info(contact_list_id, opts)
      return data
    end

    # Initiate the export of a contact list.
    # Returns 200 if received OK.
    # @param contact_list_id ContactList ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(UriReference, Fixnum, Hash)>] UriReference data, response status code and response headers
    def post_contactlists_contactlist_id_export_with_http_info(contact_list_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#post_contactlists_contactlist_id_export ..."
      end
      
      # verify the required parameter 'contact_list_id' is set
      fail "Missing the required parameter 'contact_list_id' when calling post_contactlists_contactlist_id_export" if contact_list_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/contactlists/{contactListId}/export".sub('{format}','json').sub('{' + 'contactListId' + '}', contact_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'UriReference')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#post_contactlists_contactlist_id_export\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Add phone numbers to a Dialer DNC list.
    # 
    # @param conversation_id Conversation ID
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def post_conversations_conversation_id_dnc(conversation_id, opts = {})
      post_conversations_conversation_id_dnc_with_http_info(conversation_id, opts)
      return nil
    end

    # Add phone numbers to a Dialer DNC list.
    # 
    # @param conversation_id Conversation ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def post_conversations_conversation_id_dnc_with_http_info(conversation_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#post_conversations_conversation_id_dnc ..."
      end
      
      # verify the required parameter 'conversation_id' is set
      fail "Missing the required parameter 'conversation_id' when calling post_conversations_conversation_id_dnc" if conversation_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/conversations/{conversationId}/dnc".sub('{format}','json').sub('{' + 'conversationId' + '}', conversation_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#post_conversations_conversation_id_dnc\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create dialer DNC list
    # 
    # @param body DncList
    # @param [Hash] opts the optional parameters
    # @return [DncList]
    def post_dnclists(body, opts = {})
      data, status_code, headers = post_dnclists_with_http_info(body, opts)
      return data
    end

    # Create dialer DNC list
    # 
    # @param body DncList
    # @param [Hash] opts the optional parameters
    # @return [Array<(DncList, Fixnum, Hash)>] DncList data, response status code and response headers
    def post_dnclists_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#post_dnclists ..."
      end
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling post_dnclists" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/dnclists".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'DncList')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#post_dnclists\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Initiate the export of a dnc list.
    # Returns 200 if received OK.
    # @param dnc_list_id DncList ID
    # @param [Hash] opts the optional parameters
    # @return [UriReference]
    def post_dnclists_dnclist_id_export(dnc_list_id, opts = {})
      data, status_code, headers = post_dnclists_dnclist_id_export_with_http_info(dnc_list_id, opts)
      return data
    end

    # Initiate the export of a dnc list.
    # Returns 200 if received OK.
    # @param dnc_list_id DncList ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(UriReference, Fixnum, Hash)>] UriReference data, response status code and response headers
    def post_dnclists_dnclist_id_export_with_http_info(dnc_list_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#post_dnclists_dnclist_id_export ..."
      end
      
      # verify the required parameter 'dnc_list_id' is set
      fail "Missing the required parameter 'dnc_list_id' when calling post_dnclists_dnclist_id_export" if dnc_list_id.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/dnclists/{dncListId}/export".sub('{format}','json').sub('{' + 'dncListId' + '}', dnc_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'UriReference')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#post_dnclists_dnclist_id_export\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Add phone numbers to a Dialer DNC list.
    # Only Internal DNC lists may be appended to
    # @param dnc_list_id DncList ID
    # @param body DNC Phone Numbers
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def post_dnclists_dnclist_id_phonenumbers(dnc_list_id, body, opts = {})
      post_dnclists_dnclist_id_phonenumbers_with_http_info(dnc_list_id, body, opts)
      return nil
    end

    # Add phone numbers to a Dialer DNC list.
    # Only Internal DNC lists may be appended to
    # @param dnc_list_id DncList ID
    # @param body DNC Phone Numbers
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def post_dnclists_dnclist_id_phonenumbers_with_http_info(dnc_list_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#post_dnclists_dnclist_id_phonenumbers ..."
      end
      
      # verify the required parameter 'dnc_list_id' is set
      fail "Missing the required parameter 'dnc_list_id' when calling post_dnclists_dnclist_id_phonenumbers" if dnc_list_id.nil?
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling post_dnclists_dnclist_id_phonenumbers" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/dnclists/{dncListId}/phonenumbers".sub('{format}','json').sub('{' + 'dncListId' + '}', dnc_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#post_dnclists_dnclist_id_phonenumbers\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create a Dialer Call Analysis Response Set.
    # 
    # @param body RuleSet
    # @param [Hash] opts the optional parameters
    # @return [RuleSet]
    def post_rulesets(body, opts = {})
      data, status_code, headers = post_rulesets_with_http_info(body, opts)
      return data
    end

    # Create a Dialer Call Analysis Response Set.
    # 
    # @param body RuleSet
    # @param [Hash] opts the optional parameters
    # @return [Array<(RuleSet, Fixnum, Hash)>] RuleSet data, response status code and response headers
    def post_rulesets_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#post_rulesets ..."
      end
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling post_rulesets" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/rulesets".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'RuleSet')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#post_rulesets\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create a new campaign sequence.
    # 
    # @param body Organization
    # @param [Hash] opts the optional parameters
    # @return [CampaignSequence]
    def post_sequences(body, opts = {})
      data, status_code, headers = post_sequences_with_http_info(body, opts)
      return data
    end

    # Create a new campaign sequence.
    # 
    # @param body Organization
    # @param [Hash] opts the optional parameters
    # @return [Array<(CampaignSequence, Fixnum, Hash)>] CampaignSequence data, response status code and response headers
    def post_sequences_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#post_sequences ..."
      end
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling post_sequences" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/sequences".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CampaignSequence')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#post_sequences\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update attempt limits
    # 
    # @param attempt_limits_id Attempt limits ID
    # @param body AttemptLimits
    # @param [Hash] opts the optional parameters
    # @return [AttemptLimits]
    def put_attemptlimits_attemptlimits_id(attempt_limits_id, body, opts = {})
      data, status_code, headers = put_attemptlimits_attemptlimits_id_with_http_info(attempt_limits_id, body, opts)
      return data
    end

    # Update attempt limits
    # 
    # @param attempt_limits_id Attempt limits ID
    # @param body AttemptLimits
    # @param [Hash] opts the optional parameters
    # @return [Array<(AttemptLimits, Fixnum, Hash)>] AttemptLimits data, response status code and response headers
    def put_attemptlimits_attemptlimits_id_with_http_info(attempt_limits_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#put_attemptlimits_attemptlimits_id ..."
      end
      
      # verify the required parameter 'attempt_limits_id' is set
      fail "Missing the required parameter 'attempt_limits_id' when calling put_attemptlimits_attemptlimits_id" if attempt_limits_id.nil?
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling put_attemptlimits_attemptlimits_id" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/attemptlimits/{attemptLimitsId}".sub('{format}','json').sub('{' + 'attemptLimitsId' + '}', attempt_limits_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AttemptLimits')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#put_attemptlimits_attemptlimits_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update callable time set
    # 
    # @param callable_time_set_id Callable Time Set ID
    # @param body DialerCallableTimeSet
    # @param [Hash] opts the optional parameters
    # @return [CallableTimeSet]
    def put_callabletimesets_callabletimeset_id(callable_time_set_id, body, opts = {})
      data, status_code, headers = put_callabletimesets_callabletimeset_id_with_http_info(callable_time_set_id, body, opts)
      return data
    end

    # Update callable time set
    # 
    # @param callable_time_set_id Callable Time Set ID
    # @param body DialerCallableTimeSet
    # @param [Hash] opts the optional parameters
    # @return [Array<(CallableTimeSet, Fixnum, Hash)>] CallableTimeSet data, response status code and response headers
    def put_callabletimesets_callabletimeset_id_with_http_info(callable_time_set_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#put_callabletimesets_callabletimeset_id ..."
      end
      
      # verify the required parameter 'callable_time_set_id' is set
      fail "Missing the required parameter 'callable_time_set_id' when calling put_callabletimesets_callabletimeset_id" if callable_time_set_id.nil?
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling put_callabletimesets_callabletimeset_id" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/callabletimesets/{callableTimeSetId}".sub('{format}','json').sub('{' + 'callableTimeSetId' + '}', callable_time_set_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CallableTimeSet')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#put_callabletimesets_callabletimeset_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a dialer call analysis response set.
    # 
    # @param call_analysis_set_id Call Analysis Response Set ID
    # @param body ResponseSet
    # @param [Hash] opts the optional parameters
    # @return [ResponseSet]
    def put_callanalysisresponsesets_callanalysisset_id(call_analysis_set_id, body, opts = {})
      data, status_code, headers = put_callanalysisresponsesets_callanalysisset_id_with_http_info(call_analysis_set_id, body, opts)
      return data
    end

    # Update a dialer call analysis response set.
    # 
    # @param call_analysis_set_id Call Analysis Response Set ID
    # @param body ResponseSet
    # @param [Hash] opts the optional parameters
    # @return [Array<(ResponseSet, Fixnum, Hash)>] ResponseSet data, response status code and response headers
    def put_callanalysisresponsesets_callanalysisset_id_with_http_info(call_analysis_set_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#put_callanalysisresponsesets_callanalysisset_id ..."
      end
      
      # verify the required parameter 'call_analysis_set_id' is set
      fail "Missing the required parameter 'call_analysis_set_id' when calling put_callanalysisresponsesets_callanalysisset_id" if call_analysis_set_id.nil?
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling put_callanalysisresponsesets_callanalysisset_id" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/callanalysisresponsesets/{callAnalysisSetId}".sub('{format}','json').sub('{' + 'callAnalysisSetId' + '}', call_analysis_set_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ResponseSet')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#put_callanalysisresponsesets_callanalysisset_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update Campaign Rule
    # 
    # @param campaign_rule_id Campaign Rule ID
    # @param body CampaignRule
    # @param [Hash] opts the optional parameters
    # @return [CampaignRule]
    def put_campaignrules_campaignrule_id(campaign_rule_id, body, opts = {})
      data, status_code, headers = put_campaignrules_campaignrule_id_with_http_info(campaign_rule_id, body, opts)
      return data
    end

    # Update Campaign Rule
    # 
    # @param campaign_rule_id Campaign Rule ID
    # @param body CampaignRule
    # @param [Hash] opts the optional parameters
    # @return [Array<(CampaignRule, Fixnum, Hash)>] CampaignRule data, response status code and response headers
    def put_campaignrules_campaignrule_id_with_http_info(campaign_rule_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#put_campaignrules_campaignrule_id ..."
      end
      
      # verify the required parameter 'campaign_rule_id' is set
      fail "Missing the required parameter 'campaign_rule_id' when calling put_campaignrules_campaignrule_id" if campaign_rule_id.nil?
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling put_campaignrules_campaignrule_id" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/campaignrules/{campaignRuleId}".sub('{format}','json').sub('{' + 'campaignRuleId' + '}', campaign_rule_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CampaignRule')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#put_campaignrules_campaignrule_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a campaign.
    # 
    # @param campaign_id Campaign ID
    # @param body Campaign
    # @param [Hash] opts the optional parameters
    # @return [Campaign]
    def put_campaigns_campaign_id(campaign_id, body, opts = {})
      data, status_code, headers = put_campaigns_campaign_id_with_http_info(campaign_id, body, opts)
      return data
    end

    # Update a campaign.
    # 
    # @param campaign_id Campaign ID
    # @param body Campaign
    # @param [Hash] opts the optional parameters
    # @return [Array<(Campaign, Fixnum, Hash)>] Campaign data, response status code and response headers
    def put_campaigns_campaign_id_with_http_info(campaign_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#put_campaigns_campaign_id ..."
      end
      
      # verify the required parameter 'campaign_id' is set
      fail "Missing the required parameter 'campaign_id' when calling put_campaigns_campaign_id" if campaign_id.nil?
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling put_campaigns_campaign_id" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/campaigns/{campaignId}".sub('{format}','json').sub('{' + 'campaignId' + '}', campaign_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Campaign')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#put_campaigns_campaign_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Send notification that an agent's state changed 
    # New agent state.
    # @param campaign_id Campaign ID
    # @param user_id Agent&#39;s user ID
    # @param body agent
    # @param [Hash] opts the optional parameters
    # @return [String]
    def put_campaigns_campaign_id_agents_user_id(campaign_id, user_id, body, opts = {})
      data, status_code, headers = put_campaigns_campaign_id_agents_user_id_with_http_info(campaign_id, user_id, body, opts)
      return data
    end

    # Send notification that an agent&#39;s state changed 
    # New agent state.
    # @param campaign_id Campaign ID
    # @param user_id Agent&#39;s user ID
    # @param body agent
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def put_campaigns_campaign_id_agents_user_id_with_http_info(campaign_id, user_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#put_campaigns_campaign_id_agents_user_id ..."
      end
      
      # verify the required parameter 'campaign_id' is set
      fail "Missing the required parameter 'campaign_id' when calling put_campaigns_campaign_id_agents_user_id" if campaign_id.nil?
      
      # verify the required parameter 'user_id' is set
      fail "Missing the required parameter 'user_id' when calling put_campaigns_campaign_id_agents_user_id" if user_id.nil?
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling put_campaigns_campaign_id_agents_user_id" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/campaigns/{campaignId}/agents/{userId}".sub('{format}','json').sub('{' + 'campaignId' + '}', campaign_id.to_s).sub('{' + 'userId' + '}', user_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#put_campaigns_campaign_id_agents_user_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a contact list.
    # 
    # @param contact_list_id ContactList ID
    # @param body ContactList
    # @param [Hash] opts the optional parameters
    # @return [ContactList]
    def put_contactlists_contactlist_id(contact_list_id, body, opts = {})
      data, status_code, headers = put_contactlists_contactlist_id_with_http_info(contact_list_id, body, opts)
      return data
    end

    # Update a contact list.
    # 
    # @param contact_list_id ContactList ID
    # @param body ContactList
    # @param [Hash] opts the optional parameters
    # @return [Array<(ContactList, Fixnum, Hash)>] ContactList data, response status code and response headers
    def put_contactlists_contactlist_id_with_http_info(contact_list_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#put_contactlists_contactlist_id ..."
      end
      
      # verify the required parameter 'contact_list_id' is set
      fail "Missing the required parameter 'contact_list_id' when calling put_contactlists_contactlist_id" if contact_list_id.nil?
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling put_contactlists_contactlist_id" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/contactlists/{contactListId}".sub('{format}','json').sub('{' + 'contactListId' + '}', contact_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ContactList')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#put_contactlists_contactlist_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a contact.
    # 
    # @param contact_list_id Contact List ID
    # @param contact_id Contact ID
    # @param body Contact
    # @param [Hash] opts the optional parameters
    # @return [DialerContact]
    def put_contactlists_contactlist_id_contacts_contact_id(contact_list_id, contact_id, body, opts = {})
      data, status_code, headers = put_contactlists_contactlist_id_contacts_contact_id_with_http_info(contact_list_id, contact_id, body, opts)
      return data
    end

    # Update a contact.
    # 
    # @param contact_list_id Contact List ID
    # @param contact_id Contact ID
    # @param body Contact
    # @param [Hash] opts the optional parameters
    # @return [Array<(DialerContact, Fixnum, Hash)>] DialerContact data, response status code and response headers
    def put_contactlists_contactlist_id_contacts_contact_id_with_http_info(contact_list_id, contact_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#put_contactlists_contactlist_id_contacts_contact_id ..."
      end
      
      # verify the required parameter 'contact_list_id' is set
      fail "Missing the required parameter 'contact_list_id' when calling put_contactlists_contactlist_id_contacts_contact_id" if contact_list_id.nil?
      
      # verify the required parameter 'contact_id' is set
      fail "Missing the required parameter 'contact_id' when calling put_contactlists_contactlist_id_contacts_contact_id" if contact_id.nil?
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling put_contactlists_contactlist_id_contacts_contact_id" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/contactlists/{contactListId}/contacts/{contactId}".sub('{format}','json').sub('{' + 'contactListId' + '}', contact_list_id.to_s).sub('{' + 'contactId' + '}', contact_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'DialerContact')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#put_contactlists_contactlist_id_contacts_contact_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update dialer DNC list
    # 
    # @param dnc_list_id DncList ID
    # @param body DncList
    # @param [Hash] opts the optional parameters
    # @return [DncList]
    def put_dnclists_dnclist_id(dnc_list_id, body, opts = {})
      data, status_code, headers = put_dnclists_dnclist_id_with_http_info(dnc_list_id, body, opts)
      return data
    end

    # Update dialer DNC list
    # 
    # @param dnc_list_id DncList ID
    # @param body DncList
    # @param [Hash] opts the optional parameters
    # @return [Array<(DncList, Fixnum, Hash)>] DncList data, response status code and response headers
    def put_dnclists_dnclist_id_with_http_info(dnc_list_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#put_dnclists_dnclist_id ..."
      end
      
      # verify the required parameter 'dnc_list_id' is set
      fail "Missing the required parameter 'dnc_list_id' when calling put_dnclists_dnclist_id" if dnc_list_id.nil?
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling put_dnclists_dnclist_id" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/dnclists/{dncListId}".sub('{format}','json').sub('{' + 'dncListId' + '}', dnc_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'DncList')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#put_dnclists_dnclist_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a RuleSet.
    # 
    # @param rule_set_id Rule Set ID
    # @param body RuleSet
    # @param [Hash] opts the optional parameters
    # @return [RuleSet]
    def put_rulesets_ruleset_id(rule_set_id, body, opts = {})
      data, status_code, headers = put_rulesets_ruleset_id_with_http_info(rule_set_id, body, opts)
      return data
    end

    # Update a RuleSet.
    # 
    # @param rule_set_id Rule Set ID
    # @param body RuleSet
    # @param [Hash] opts the optional parameters
    # @return [Array<(RuleSet, Fixnum, Hash)>] RuleSet data, response status code and response headers
    def put_rulesets_ruleset_id_with_http_info(rule_set_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#put_rulesets_ruleset_id ..."
      end
      
      # verify the required parameter 'rule_set_id' is set
      fail "Missing the required parameter 'rule_set_id' when calling put_rulesets_ruleset_id" if rule_set_id.nil?
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling put_rulesets_ruleset_id" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/rulesets/{ruleSetId}".sub('{format}','json').sub('{' + 'ruleSetId' + '}', rule_set_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'RuleSet')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#put_rulesets_ruleset_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a new campaign schedule.
    # 
    # @param campaign_id Campaign ID
    # @param body CampaignSchedule
    # @param [Hash] opts the optional parameters
    # @return [CampaignSchedule]
    def put_schedules_campaigns_campaign_id(campaign_id, body, opts = {})
      data, status_code, headers = put_schedules_campaigns_campaign_id_with_http_info(campaign_id, body, opts)
      return data
    end

    # Update a new campaign schedule.
    # 
    # @param campaign_id Campaign ID
    # @param body CampaignSchedule
    # @param [Hash] opts the optional parameters
    # @return [Array<(CampaignSchedule, Fixnum, Hash)>] CampaignSchedule data, response status code and response headers
    def put_schedules_campaigns_campaign_id_with_http_info(campaign_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#put_schedules_campaigns_campaign_id ..."
      end
      
      # verify the required parameter 'campaign_id' is set
      fail "Missing the required parameter 'campaign_id' when calling put_schedules_campaigns_campaign_id" if campaign_id.nil?
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling put_schedules_campaigns_campaign_id" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/schedules/campaigns/{campaignId}".sub('{format}','json').sub('{' + 'campaignId' + '}', campaign_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CampaignSchedule')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#put_schedules_campaigns_campaign_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a new sequence schedule.
    # 
    # @param sequence_id Sequence ID
    # @param body SequenceSchedule
    # @param [Hash] opts the optional parameters
    # @return [SequenceSchedule]
    def put_schedules_sequences_sequence_id(sequence_id, body, opts = {})
      data, status_code, headers = put_schedules_sequences_sequence_id_with_http_info(sequence_id, body, opts)
      return data
    end

    # Update a new sequence schedule.
    # 
    # @param sequence_id Sequence ID
    # @param body SequenceSchedule
    # @param [Hash] opts the optional parameters
    # @return [Array<(SequenceSchedule, Fixnum, Hash)>] SequenceSchedule data, response status code and response headers
    def put_schedules_sequences_sequence_id_with_http_info(sequence_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#put_schedules_sequences_sequence_id ..."
      end
      
      # verify the required parameter 'sequence_id' is set
      fail "Missing the required parameter 'sequence_id' when calling put_schedules_sequences_sequence_id" if sequence_id.nil?
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling put_schedules_sequences_sequence_id" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/schedules/sequences/{sequenceId}".sub('{format}','json').sub('{' + 'sequenceId' + '}', sequence_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'SequenceSchedule')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#put_schedules_sequences_sequence_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a new campaign sequence.
    # 
    # @param sequence_id Campaign Sequence ID
    # @param body Organization
    # @param [Hash] opts the optional parameters
    # @return [CampaignSequence]
    def put_sequences_sequence_id(sequence_id, body, opts = {})
      data, status_code, headers = put_sequences_sequence_id_with_http_info(sequence_id, body, opts)
      return data
    end

    # Update a new campaign sequence.
    # 
    # @param sequence_id Campaign Sequence ID
    # @param body Organization
    # @param [Hash] opts the optional parameters
    # @return [Array<(CampaignSequence, Fixnum, Hash)>] CampaignSequence data, response status code and response headers
    def put_sequences_sequence_id_with_http_info(sequence_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#put_sequences_sequence_id ..."
      end
      
      # verify the required parameter 'sequence_id' is set
      fail "Missing the required parameter 'sequence_id' when calling put_sequences_sequence_id" if sequence_id.nil?
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling put_sequences_sequence_id" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/sequences/{sequenceId}".sub('{format}','json').sub('{' + 'sequenceId' + '}', sequence_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CampaignSequence')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#put_sequences_sequence_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update the Dialer wrap up code mapping.
    # 
    # @param body wrapUpCodeMapping
    # @param [Hash] opts the optional parameters
    # @return [WrapUpCodeMapping]
    def put_wrapupcodemappings(body, opts = {})
      data, status_code, headers = put_wrapupcodemappings_with_http_info(body, opts)
      return data
    end

    # Update the Dialer wrap up code mapping.
    # 
    # @param body wrapUpCodeMapping
    # @param [Hash] opts the optional parameters
    # @return [Array<(WrapUpCodeMapping, Fixnum, Hash)>] WrapUpCodeMapping data, response status code and response headers
    def put_wrapupcodemappings_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: OutboundApi#put_wrapupcodemappings ..."
      end
      
      # verify the required parameter 'body' is set
      fail "Missing the required parameter 'body' when calling put_wrapupcodemappings" if body.nil?
      
      # resource path
      local_var_path = "/api/v2/outbound/wrapupcodemappings".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      _header_accept = ['application/json']
      _header_accept_result = @api_client.select_header_accept(_header_accept) and header_params['Accept'] = _header_accept_result

      # HTTP header 'Content-Type'
      _header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      
      auth_names = ['PureCloud Auth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'WrapUpCodeMapping')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OutboundApi#put_wrapupcodemappings\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
